'use strict';

Object.defineProperty(exports, '__esModule', { value: true });

var React = require('react');
var ArrowDropDownIcon = require('@mui/icons-material/ArrowDropDown');
var ClearIcon = require('@mui/icons-material/Clear');
var material = require('@mui/material');
var TextField = require('@mui/material/TextField');
var colors = require('@mui/material/colors');
var LocalizationProvider = require('@mui/x-date-pickers/LocalizationProvider');
var xDatePickers = require('@mui/x-date-pickers');
var AdapterDayjs = require('@mui/x-date-pickers/AdapterDayjs');
var iconsMaterial = require('@mui/icons-material');
var styles = require('@mui/material/styles');
var VisibilityIcon = require('@mui/icons-material/Visibility');
var VisibilityOffIcon = require('@mui/icons-material/VisibilityOff');

function _interopDefaultLegacy (e) { return e && typeof e === 'object' && 'default' in e ? e : { 'default': e }; }

var React__default = /*#__PURE__*/_interopDefaultLegacy(React);
var ArrowDropDownIcon__default = /*#__PURE__*/_interopDefaultLegacy(ArrowDropDownIcon);
var ClearIcon__default = /*#__PURE__*/_interopDefaultLegacy(ClearIcon);
var TextField__default = /*#__PURE__*/_interopDefaultLegacy(TextField);
var VisibilityIcon__default = /*#__PURE__*/_interopDefaultLegacy(VisibilityIcon);
var VisibilityOffIcon__default = /*#__PURE__*/_interopDefaultLegacy(VisibilityOffIcon);

/******************************************************************************
Copyright (c) Microsoft Corporation.

Permission to use, copy, modify, and/or distribute this software for any
purpose with or without fee is hereby granted.

THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
PERFORMANCE OF THIS SOFTWARE.
***************************************************************************** */

function __rest(s, e) {
    var t = {};
    for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
        t[p] = s[p];
    if (s != null && typeof Object.getOwnPropertySymbols === "function")
        for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
            if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                t[p[i]] = s[p[i]];
        }
    return t;
}

function __awaiter(thisArg, _arguments, P, generator) {
    function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
    return new (P || (P = Promise))(function (resolve, reject) {
        function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
        function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
        function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
        step((generator = generator.apply(thisArg, _arguments || [])).next());
    });
}

typeof SuppressedError === "function" ? SuppressedError : function (error, suppressed, message) {
    var e = new Error(message);
    return e.name = "SuppressedError", e.error = error, e.suppressed = suppressed, e;
};

const randomString = (length) => {
    var result = '';
    var characters = 'ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789';
    var charactersLength = characters.length;
    for (var i = 0; i < length; i++) {
        result += characters.charAt(Math.floor(Math.random() * charactersLength));
    }
    return result;
};
const mask = (value, pattern, placeholder = '') => {
    let i = 0, v = value.toString();
    return pattern.replace(/\./g, (_) => v[i++] || placeholder);
};
const isNull = (data) => {
    return data === null;
};
const checkValue = (value) => {
    if (value === null)
        return false;
    if (value === undefined)
        return false;
    return true;
};
const selectFromObject = (selector, data) => {
    const regex = new RegExp('.*[.*=.*]');
    let splitSelector = selector.split('.');
    let workingObject = data;
    splitSelector.forEach((selectorItem) => {
        if (!workingObject)
            workingObject = {};
        if (regex.test(selectorItem)) {
            const objectBeforeQuery = selectorItem.replace(/\[.*\]/g, '');
            if (objectBeforeQuery) {
                workingObject = workingObject[objectBeforeQuery];
            }
            if (!Array.isArray(workingObject))
                return;
            const splitQuery = selectorItem.replace(/.*\[|\]/g, '').split('=');
            const queryKey = splitQuery[0].trim();
            const queryValue = isNaN(parseInt(splitQuery[1])) ? splitQuery[1] : parseInt(splitQuery[1]);
            workingObject = workingObject.find((ob) => ob[queryKey] === queryValue);
        }
        else {
            workingObject = workingObject[selectorItem];
        }
    });
    return workingObject;
};
const setToObject = (selector, value, object) => {
    // value = typeof value !== 'boolean' && !Array.isArray(value) && value && !isNaN(value) ? parseInt(value, 10) : value
    const regex = new RegExp('.*[.*=.*]');
    let splitSelector = selector.split('.');
    if (splitSelector.length > 1) {
        let workingObject = object;
        splitSelector.forEach((selectorItem, index) => {
            const isLast = splitSelector.length === index + 1;
            if (regex.test(selectorItem)) {
                const replacedSelectorItem = selectorItem.replace(/\[.*\]/, '');
                if (!workingObject.hasOwnProperty(replacedSelectorItem))
                    workingObject[replacedSelectorItem] = [];
                const splitQuery = selectorItem.replace(/.*\[|\]/g, '').split('=');
                const queryKey = splitQuery[0].trim();
                const queryValue = isNaN(parseInt(splitQuery[1])) ? splitQuery[1] : parseInt(splitQuery[1]);
                const exists = workingObject[replacedSelectorItem].find((item) => item[queryKey] === queryValue);
                if (exists) {
                    workingObject = exists;
                }
                else {
                    const newObject = { [queryKey]: queryValue };
                    workingObject[replacedSelectorItem].push(newObject);
                    workingObject = newObject;
                }
            }
            else {
                if (isLast) {
                    workingObject[selectorItem] = value;
                }
                else {
                    if (!workingObject.hasOwnProperty(selectorItem))
                        workingObject[selectorItem] = {};
                    workingObject = workingObject[selectorItem];
                }
            }
        });
    }
    else {
        object[selector] = value;
    }
    return object;
};

// import { AutocompleteInputProps, AutocompleteInputValueType, AutocompleteOptionType, AutocompleteValueType } from './autocomplete.types';
const LoadingComponent$1 = () => (React__default["default"].createElement(material.Grow, { in: true, timeout: 550 },
    React__default["default"].createElement(material.Box, { sx: { paddingRight: '8px', paddingTop: '4px' } },
        React__default["default"].createElement(material.CircularProgress, { size: 18 }))));
class AutocompleteInput extends React.Component {
    constructor() {
        super(...arguments);
        this.state = {
            value: this.getValuesFrom(this.props.defaultValue || null),
            error: false
        };
        this.onChange = (_, option, reason, details) => {
            var _a, _b;
            if (Array.isArray(option)) {
                this.setValue(option.map(i => typeof i === "string" ? i : i.value));
            }
            else {
                this.setValue(typeof option === "string" ? option : option.value);
            }
            (_b = (_a = this.props).onChange) === null || _b === void 0 ? void 0 : _b.call(_a, _, option, reason, details);
        };
        this.onClick = (event) => {
            var _a, _b;
            clearTimeout(this.validationTimeout);
            this.setState(Object.assign(Object.assign({}, this.state), { error: false }));
            (_b = (_a = this.props).onClick) === null || _b === void 0 ? void 0 : _b.call(_a, event);
        };
        this.click = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.click();
        };
        this.focus = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.focus();
        };
        this.blur = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.blur();
        };
        this.onInputBlur = (event) => {
            var _a, _b;
            if (!this.props.multiple && this.props.freeSolo) {
                this.setValue(event.target.value);
            }
            (_b = (_a = this.props.InputProps) === null || _a === void 0 ? void 0 : _a.onBlur) === null || _b === void 0 ? void 0 : _b.call(_a, event);
        };
        this.renderOption = (props, option) => {
            const { key } = props, rest = __rest(props, ["key"]);
            return (React__default["default"].createElement("li", Object.assign({ key: key }, rest), typeof option === "object" ? option.label : (option.toString())));
        };
        this.getOptionLabel = (option) => typeof option === "object" ? option.label : (option.toString());
        this.isOptionEqualToValue = (option, value) => {
            if (!value)
                return false;
            return typeof option === "string" ? option === (typeof value === "string" ? value : value.value.toString()) : option.value.toString() === (typeof value === "string" ? value : value.value.toString());
        };
    }
    shouldComponentUpdate(nextProps, nextState) {
        var _a, _b;
        switch (true) {
            case this.state.value !== nextState.value:
            case this.getValueForCheck(this.state.value || undefined) !== this.getValueForCheck(nextState.value || undefined):
            case this.state.error !== nextState.error:
            case ((_a = this.props.options) === null || _a === void 0 ? void 0 : _a.map((i) => this.optionGetter(i, 'value')).join('@')) !== ((_b = nextProps.options) === null || _b === void 0 ? void 0 : _b.map((i) => this.optionGetter(i, 'value')).join('@')):
            case this.props.loading !== nextProps.loading:
            case this.props.loadingText !== nextProps.loadingText:
            case this.props.label !== nextProps.label:
            case this.props.disabled !== nextProps.disabled:
                return true;
            default: return false;
        }
    }
    getValuesFrom(value) {
        if (!value)
            return null;
        if (this.props.multiple && !Array.isArray(value))
            return null;
        if (!this.props.multiple && Array.isArray(value))
            return null;
        if (this.props.freeSolo && !this.props.multiple) {
            const exists = this.props.options.find(i => (typeof i === "string" ? i : i.value) === value || (typeof i === "string" ? i : i.label) === value);
            return exists || { label: (value === null || value === void 0 ? void 0 : value.toString()) || "", value: (value === null || value === void 0 ? void 0 : value.toString()) || "" };
        }
        if (this.props.freeSolo && this.props.multiple && typeof value === "object" && Array.isArray(value)) {
            const outputOptions = value.map(valueItem => {
                const exists = this.props.options.find(i => (typeof i === "string" ? i : i.value) === valueItem);
                return exists || { label: (valueItem === null || valueItem === void 0 ? void 0 : valueItem.toString().trim()) || "", value: (valueItem === null || valueItem === void 0 ? void 0 : valueItem.toString().trim()) || "" };
            });
            return outputOptions;
        }
        if (typeof value === "object" && Array.isArray(value)) {
            return this.props.options.filter(i => value.indexOf(typeof i === "string" ? i : i.value) > -1);
        }
        else if (value) {
            return this.props.options.find(i => (typeof i === "string" ? i : i.value) === value);
        }
        return undefined;
    }
    componentDidUpdate(props) {
        var _a, _b;
        if (((_a = this.props.options) === null || _a === void 0 ? void 0 : _a.map((i) => this.optionGetter(i, 'value')).join('@')) !== ((_b = props.options) === null || _b === void 0 ? void 0 : _b.map((i) => this.optionGetter(i, 'value')).join('@'))) {
            if (!this.props.disableClearOnChangeOptions)
                this.clear();
        }
    }
    setValue(value) {
        const valueToSet = this.getValuesFrom(value);
        return new Promise((resolve) => {
            this.setState(Object.assign(Object.assign({}, this.state), { value: valueToSet }), () => {
                var _a, _b, _c, _d;
                (_b = (_a = this.props)._call_parent_for_update) === null || _b === void 0 ? void 0 : _b.call(_a);
                (_d = (_c = this.props).onChangeValue) === null || _d === void 0 ? void 0 : _d.call(_c, value);
                resolve(value);
            });
        });
    }
    getValue() {
        var _a;
        return (Array.isArray(this.state.value)
            ? this.state.value.map(i => typeof i === "string" ? i : i.value)
            : typeof this.state.value === "string" ? this.state.value : (_a = this.state.value) === null || _a === void 0 ? void 0 : _a.value) || (this.props.multiple ? [] : null);
    }
    clear(withoutDefaults = false) {
        return this.setValue((!withoutDefaults ? this.props.defaultValue : null) || null);
    }
    validation() {
        if (!this.getValueForCheck(this.state.value) && this.props.required) {
            clearTimeout(this.validationTimeout);
            this.setState(Object.assign(Object.assign({}, this.state), { error: true }));
            this.validationTimeout = setTimeout(() => {
                this.setState(Object.assign(Object.assign({}, this.state), { error: false }));
            }, 3000);
            return false;
        }
        return true;
    }
    optionGetter(item, selector = "value") {
        var _a;
        return typeof item === "string" || typeof item === "number" || isNull(item) ? (item !== null && item !== void 0 ? item : "") : ((_a = item === null || item === void 0 ? void 0 : item[selector]) !== null && _a !== void 0 ? _a : "");
    }
    getValueForCheck(value) {
        return !isNull(value) && Array.isArray(value) ? value.join('@') : value;
    }
    render() {
        var _a, _b, _c, _d, _e;
        const _f = this.props, { defaultValue, onChangeValue, InputProps, renderInput, label, variant, required, visible, _call_parent_for_update } = _f, restProps = __rest(_f, ["defaultValue", "onChangeValue", "InputProps", "renderInput", "label", "variant", "required", "visible", "_call_parent_for_update"]);
        let variantWidth = '207px';
        if (this.props.variant === "outlined")
            variantWidth = "235px";
        if (this.props.variant === "filled")
            variantWidth = "231px";
        const inputWidth = this.props.fullWidth ? '100%' : variantWidth;
        return (React__default["default"].createElement(material.Autocomplete, Object.assign({}, restProps, { sx: Object.assign({ width: inputWidth, display: 'inline-flex' }, this.props.sx), renderOption: (_a = this.props.renderOption) !== null && _a !== void 0 ? _a : this.renderOption, getOptionLabel: (_b = this.props.getOptionLabel) !== null && _b !== void 0 ? _b : this.getOptionLabel, onChange: this.onChange, disableClearable: (_c = this.props.disableClearable) !== null && _c !== void 0 ? _c : true, size: this.props.size || !variant || variant === "standard" ? "small" : "medium", value: (_d = this.state.value) !== null && _d !== void 0 ? _d : (this.props.multiple ? [] : (this.props.freeSolo ? "" : null)), disabled: this.props.disabled || this.props.loading, clearOnBlur: this.props.multiple || (this.props.multiple && this.props.freeSolo) || (!this.props.multiple && !this.props.freeSolo), popupIcon: this.props.loading ? React__default["default"].createElement(LoadingComponent$1, null) : (this.props.popupIcon || React__default["default"].createElement(ArrowDropDownIcon__default["default"], null)), isOptionEqualToValue: (_e = this.props.isOptionEqualToValue) !== null && _e !== void 0 ? _e : this.isOptionEqualToValue, renderInput: renderInput ? (params) => {
                params.inputRef = (el) => this.inputRef = el;
                params.error = this.state.error;
                params.variant = variant || "standard";
                params.label = label;
                params.required = required;
                params.onClick = this.onClick;
                return renderInput(params);
            } : ((params) => {
                var _a;
                return (React__default["default"].createElement(TextField__default["default"], Object.assign({}, params, InputProps, { label: label, placeholder: InputProps === null || InputProps === void 0 ? void 0 : InputProps.placeholder, variant: variant || "standard", required: required, onClick: this.onClick, error: this.state.error, inputRef: el => this.inputRef = el, slotProps: {
                        input: Object.assign(Object.assign(Object.assign({}, (_a = InputProps === null || InputProps === void 0 ? void 0 : InputProps.slotProps) === null || _a === void 0 ? void 0 : _a.input), params.InputProps), { onBlur: this.onInputBlur, endAdornment: (React__default["default"].createElement(material.InputAdornment, { position: "end" },
                                params.InputProps.endAdornment,
                                !this.props.disableClearable && this.getValueForCheck(this.state.value) ? (React__default["default"].createElement(material.IconButton, { size: "small", onClick: (e) => {
                                        e.stopPropagation();
                                        this.clear(true);
                                    } },
                                    React__default["default"].createElement(ClearIcon__default["default"], { fontSize: "small" }))) : null)) })
                    } })));
            }) })));
    }
}

class CheckboxInput extends React.Component {
    constructor() {
        super(...arguments);
        this.state = {
            value: this.props.defaultChecked || false,
            error: false
        };
        this.onChange = (event, checked) => {
            var _a, _b;
            this.setValue(checked || false);
            (_b = (_a = this.props).onChange) === null || _b === void 0 ? void 0 : _b.call(_a, event, checked);
        };
        this.onClick = (event) => {
            var _a, _b;
            clearTimeout(this.validationTimeout);
            this.setState(Object.assign(Object.assign({}, this.state), { error: false }));
            (_b = (_a = this.props).onClick) === null || _b === void 0 ? void 0 : _b.call(_a, event);
        };
        this.click = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.click();
        };
        this.focus = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.focus();
        };
        this.blur = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.blur();
        };
    }
    shouldComponentUpdate(nextProps, nextState) {
        switch (true) {
            case this.state.value !== nextState.value:
            case this.state.error !== nextState.error:
            case this.props.label !== nextProps.label:
            case this.props.disabled !== nextProps.disabled:
                return true;
            default: return false;
        }
    }
    setValue(value) {
        if (value === this.state.value)
            return Promise.resolve(value);
        return new Promise((resolve) => {
            this.setState(Object.assign(Object.assign({}, this.state), { value }), () => {
                var _a, _b, _c, _d;
                (_b = (_a = this.props)._call_parent_for_update) === null || _b === void 0 ? void 0 : _b.call(_a);
                (_d = (_c = this.props).onChangeValue) === null || _d === void 0 ? void 0 : _d.call(_c, value);
                resolve(value);
            });
        });
    }
    getValue() {
        return this.state.value || false;
    }
    clear() {
        return this.setValue(this.props.checked || this.props.defaultChecked || false);
    }
    validation() {
        if (!this.state.value && this.props.required) {
            clearTimeout(this.validationTimeout);
            this.setState(Object.assign(Object.assign({}, this.state), { error: true }));
            this.validationTimeout = setTimeout(() => {
                this.setState(Object.assign(Object.assign({}, this.state), { error: false }));
            }, 3000);
            return false;
        }
        return true;
    }
    render() {
        const _a = this.props, restProps = __rest(_a, ["defaultChecked", "defaultValue", "onChangeValue", "visible", "_call_parent_for_update"]);
        const label = this.props.label + (this.props.required ? ' *' : '');
        return (React__default["default"].createElement(material.FormControlLabel, { onClick: this.onClick, control: React__default["default"].createElement(material.Checkbox, Object.assign({}, restProps, { sx: { color: this.state.error ? colors.red[700] : colors.grey[700] }, checked: this.state.value, onChange: this.onChange, inputRef: el => this.inputRef = el })), style: { userSelect: 'none' }, label: label }));
    }
}

class CustomInput extends React.Component {
    constructor() {
        super(...arguments);
        this.state = {
            value: null,
            error: false
        };
        this.click = () => {
            var _a;
            (_a = this.elementRef) === null || _a === void 0 ? void 0 : _a.click();
        };
        this.focus = () => {
            var _a;
            (_a = this.elementRef) === null || _a === void 0 ? void 0 : _a.focus();
        };
        this.blur = () => {
            var _a;
            (_a = this.elementRef) === null || _a === void 0 ? void 0 : _a.blur();
        };
    }
    setValue(value) {
        var _a, _b;
        if (typeof ((_a = this.elementRef) === null || _a === void 0 ? void 0 : _a.setValue) === "function") {
            return (_b = this.elementRef) === null || _b === void 0 ? void 0 : _b.setValue(value);
        }
        return Promise.resolve(null);
    }
    getValue() {
        var _a, _b;
        if (typeof ((_a = this.elementRef) === null || _a === void 0 ? void 0 : _a.getValue) === "function") {
            return (_b = this.elementRef) === null || _b === void 0 ? void 0 : _b.getValue();
        }
        return null;
    }
    clear() {
        var _a, _b;
        if (typeof ((_a = this.elementRef) === null || _a === void 0 ? void 0 : _a.clear) === "function") {
            return (_b = this.elementRef) === null || _b === void 0 ? void 0 : _b.clear();
        }
        return Promise.resolve(null);
    }
    validation() {
        var _a, _b;
        if (typeof ((_a = this.elementRef) === null || _a === void 0 ? void 0 : _a.validation) === "function") {
            return (_b = this.elementRef) === null || _b === void 0 ? void 0 : _b.validation();
        }
        return true;
    }
    render() {
        const _a = this.props, { element } = _a, rest = __rest(_a, ["element"]);
        const render = React__default["default"].createElement(element, Object.assign({ ref: (el) => this.elementRef = el }, rest));
        return (React__default["default"].createElement(React.Fragment, null,
            " ",
            render,
            " "));
    }
}

class DateInput extends React.Component {
    constructor() {
        super(...arguments);
        this.state = {
            value: this.props.defaultValue || null,
            error: false
        };
        this.onChange = (value, context) => {
            var _a, _b;
            this.setValue(value);
            (_b = (_a = this.props).onChange) === null || _b === void 0 ? void 0 : _b.call(_a, value, context);
        };
        this.onClick = (event) => {
            var _a, _b;
            clearTimeout(this.validationTimeout);
            this.setState(Object.assign(Object.assign({}, this.state), { error: false }));
            (_b = (_a = this.props.InputProps) === null || _a === void 0 ? void 0 : _a.onClick) === null || _b === void 0 ? void 0 : _b.call(_a, event);
        };
        this.click = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.click();
        };
        this.focus = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.focus();
        };
        this.blur = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.blur();
        };
    }
    shouldComponentUpdate(nextProps, nextState) {
        switch (true) {
            case this.state.value !== nextState.value:
            case this.state.error !== nextState.error:
            case this.props.label !== nextProps.label:
            case this.props.disabled !== nextProps.disabled:
                return true;
            default: return false;
        }
    }
    setValue(value) {
        if (value === this.state.value)
            return Promise.resolve(value);
        return new Promise((resolve) => {
            this.setState(Object.assign(Object.assign({}, this.state), { value }), () => {
                var _a, _b, _c, _d;
                (_b = (_a = this.props)._call_parent_for_update) === null || _b === void 0 ? void 0 : _b.call(_a);
                (_d = (_c = this.props).onChangeValue) === null || _d === void 0 ? void 0 : _d.call(_c, value);
                resolve(value);
            });
        });
    }
    getValue() {
        return this.state.value || null;
    }
    clear() {
        return this.setValue(this.props.defaultValue || null);
    }
    validation() {
        if (!this.state.value && this.props.required) {
            clearTimeout(this.validationTimeout);
            this.setState(Object.assign(Object.assign({}, this.state), { error: true }));
            this.validationTimeout = setTimeout(() => {
                this.setState(Object.assign(Object.assign({}, this.state), { error: false }));
            }, 3000);
            return false;
        }
        return true;
    }
    render() {
        const _a = this.props, { onChangeValue, defaultValue, dateAdapter, variant, required, visible, _call_parent_for_update } = _a, restProps = __rest(_a, ["onChangeValue", "defaultValue", "dateAdapter", "variant", "required", "visible", "_call_parent_for_update"]);
        return (React__default["default"].createElement(LocalizationProvider.LocalizationProvider, { dateAdapter: dateAdapter !== null && dateAdapter !== void 0 ? dateAdapter : AdapterDayjs.AdapterDayjs },
            React__default["default"].createElement(xDatePickers.DatePicker, Object.assign({}, restProps, { value: this.state.value, onChange: this.onChange, inputRef: el => this.inputRef = el, slots: {
                    textField: (params) => {
                        var _a;
                        return (React__default["default"].createElement(TextField__default["default"], Object.assign({}, params, (_a = restProps.slotProps) === null || _a === void 0 ? void 0 : _a.textField, { fullWidth: this.props.fullWidth || false, variant: variant || 'standard', required: required || false, error: this.state.error, onClick: this.onClick })));
                    }
                } })))
        // <LocalizationProvider dateAdapter={dateAdapter || AdapterDayjs}>
        // <DatePicker
        // {...restProps}
        // value={this.state.value}
        // onChange={this.onChange}
        // inputRef={el => this.inputRef = el}
        // renderInput={(params: TextFieldProps) => (
        //     <TextField
        //         {...params}
        //         // inputProps={{
        //         //     ...params.inputProps,
        //         //     ...this.props.inputProps
        //         // }}
        //         fullWidth={this.props.fullWidth || false}
        //         variant={variant || 'standard'}
        //         required={required || false}
        //         error={this.state.error}
        //         onClick={this.onClick}
        //     />
        // )}
        // />
        // {/* </LocalizationProvider> */ }
        );
    }
}

class DatetimeInput extends React.Component {
    constructor() {
        super(...arguments);
        this.state = {
            value: this.props.defaultValue || null,
            error: false
        };
        this.onChange = (value, context) => {
            var _a, _b;
            this.setValue(value || null);
            (_b = (_a = this.props).onChange) === null || _b === void 0 ? void 0 : _b.call(_a, value, context);
        };
        this.onClick = (event) => {
            var _a, _b;
            clearTimeout(this.validationTimeout);
            this.setState(Object.assign(Object.assign({}, this.state), { error: false }));
            (_b = (_a = this.props.InputProps) === null || _a === void 0 ? void 0 : _a.onClick) === null || _b === void 0 ? void 0 : _b.call(_a, event);
        };
        this.click = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.click();
        };
        this.focus = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.focus();
        };
        this.blur = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.blur();
        };
    }
    shouldComponentUpdate(nextProps, nextState) {
        switch (true) {
            case this.state.value !== nextState.value:
            case this.state.error !== nextState.error:
            case this.props.label !== nextProps.label:
            case this.props.disabled !== nextProps.disabled:
                return true;
            default: return false;
        }
    }
    setValue(value) {
        if (value === this.state.value)
            return Promise.resolve(value);
        return new Promise((resolve) => {
            this.setState(Object.assign(Object.assign({}, this.state), { value }), () => {
                var _a, _b, _c, _d;
                (_b = (_a = this.props)._call_parent_for_update) === null || _b === void 0 ? void 0 : _b.call(_a);
                (_d = (_c = this.props).onChangeValue) === null || _d === void 0 ? void 0 : _d.call(_c, value);
                resolve(value);
            });
        });
    }
    getValue() {
        return this.state.value || null;
    }
    clear() {
        return this.setValue(this.props.defaultValue || null);
    }
    validation() {
        if (!this.state.value && this.props.required) {
            clearTimeout(this.validationTimeout);
            this.setState(Object.assign(Object.assign({}, this.state), { error: true }));
            this.validationTimeout = setTimeout(() => {
                this.setState(Object.assign(Object.assign({}, this.state), { error: false }));
            }, 3000);
            return false;
        }
        return true;
    }
    render() {
        const _a = this.props, { onChangeValue, defaultValue, dateAdapter, variant, required, visible, _call_parent_for_update } = _a, restProps = __rest(_a, ["onChangeValue", "defaultValue", "dateAdapter", "variant", "required", "visible", "_call_parent_for_update"]);
        return (React__default["default"].createElement(xDatePickers.LocalizationProvider, { dateAdapter: dateAdapter || AdapterDayjs.AdapterDayjs },
            React__default["default"].createElement(xDatePickers.DateTimePicker, Object.assign({}, restProps, { ampm: this.props.ampm || false, value: this.state.value, onChange: this.onChange, inputRef: el => this.inputRef = el, slotProps: {
                    textField: (params) => (React__default["default"].createElement(TextField__default["default"], Object.assign({}, params, { fullWidth: this.props.fullWidth || false, variant: variant || 'standard', required: required || false, error: this.state.error, onClick: this.onClick })))
                } }))));
    }
}

class FileInput extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            value: this.props.defaultValue || null,
            error: false,
            inputKey: randomString(20)
        };
        this.inputIdentity = '';
        this.textHelperIdentity = '';
        this.onChange = (event) => {
            var _a, _b;
            let value = event.target.files;
            this.setValue(value || null);
            (_b = (_a = this.props).onChange) === null || _b === void 0 ? void 0 : _b.call(_a, event);
        };
        this.onClick = (event) => {
            var _a, _b;
            clearTimeout(this.validationTimeout);
            this.setState(Object.assign(Object.assign({}, this.state), { error: false }));
            (_b = (_a = this.props).onClick) === null || _b === void 0 ? void 0 : _b.call(_a, event);
        };
        this.click = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.click();
        };
        this.focus = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.focus();
        };
        this.blur = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.blur();
        };
        this.inputIdentity = randomString(20);
        this.textHelperIdentity = randomString(20);
    }
    shouldComponentUpdate(nextProps, nextState) {
        switch (true) {
            case this.state.value !== nextState.value:
            case this.state.error !== nextState.error:
            case this.props.label !== nextProps.label:
            case this.props.disabled !== nextProps.disabled:
                return true;
            default: return false;
        }
    }
    setValue(value) {
        if (value === this.state.value)
            return Promise.resolve(value);
        return new Promise((resolve) => {
            const inputKey = !value ? randomString(20) : this.state.inputKey;
            this.setState(Object.assign(Object.assign({}, this.state), { value, inputKey }), () => {
                var _a, _b, _c, _d;
                if (this.inputRef && value) {
                    this.inputRef.files = value;
                }
                (_b = (_a = this.props)._call_parent_for_update) === null || _b === void 0 ? void 0 : _b.call(_a);
                (_d = (_c = this.props).onChangeValue) === null || _d === void 0 ? void 0 : _d.call(_c, value);
                resolve(value);
            });
        });
    }
    getValue() {
        return this.state.value || null;
    }
    clear() {
        return this.setValue(this.props.defaultValue || null);
    }
    validation() {
        if (!this.state.value && this.props.required) {
            clearTimeout(this.validationTimeout);
            this.setState(Object.assign(Object.assign({}, this.state), { error: true }));
            this.validationTimeout = setTimeout(() => {
                this.setState(Object.assign(Object.assign({}, this.state), { error: false }));
            }, 3000);
            return false;
        }
        return true;
    }
    render() {
        var _a, _b;
        const _c = this.props, { defaultValue, onChangeValue, label, helperText, FormControlProps, InputLabelProps, FormHelperTextProps, InputProps, multiple, visible, _call_parent_for_update } = _c, restProps = __rest(_c, ["defaultValue", "onChangeValue", "label", "helperText", "FormControlProps", "InputLabelProps", "FormHelperTextProps", "InputProps", "multiple", "visible", "_call_parent_for_update"]);
        return (React__default["default"].createElement(material.FormControl, Object.assign({}, FormControlProps, { variant: (_a = FormControlProps === null || FormControlProps === void 0 ? void 0 : FormControlProps.variant) !== null && _a !== void 0 ? _a : 'standard' }),
            this.props.label ? (React__default["default"].createElement(material.InputLabel, Object.assign({}, InputLabelProps, { shrink: (_b = InputLabelProps === null || InputLabelProps === void 0 ? void 0 : InputLabelProps.shrink) !== null && _b !== void 0 ? _b : true, htmlFor: this.inputIdentity }), this.props.label)) : null,
            React__default["default"].createElement(material.Input, Object.assign({}, restProps, { id: this.inputIdentity, "aria-describedby": this.textHelperIdentity, type: "file", inputProps: Object.assign(Object.assign({ multiple: multiple || false }, InputProps), { key: this.state.inputKey }), error: this.state.error, onChange: this.onChange, onClick: this.onClick, 
                // value={this.state.value?.length ? this.state.value[0].name : ''}
                inputRef: el => this.inputRef = el })),
            helperText ? (React__default["default"].createElement(material.FormHelperText, Object.assign({}, FormHelperTextProps, { id: this.textHelperIdentity }), helperText)) : null));
    }
}

class GroupInput extends React.Component {
    constructor(props) {
        super(props);
        this.state = {
            error: false,
            value: null
        };
        this.onChangeValue = (data) => {
            var _a, _b, _c, _d;
            (_b = (_a = this.props)._call_parent_for_update) === null || _b === void 0 ? void 0 : _b.call(_a);
            (_d = (_c = this.props).onChangeValue) === null || _d === void 0 ? void 0 : _d.call(_c, data);
        };
        this.click = () => { };
        this.focus = () => { };
        this.blur = () => { };
        this.builderRef = React.createRef();
    }
    setValue(values) {
        if (!this.builderRef.current || !values)
            return Promise.reject(values);
        return this.builderRef.current.setValues(values);
    }
    getValue(validation) {
        var _a;
        return (_a = this.builderRef.current) === null || _a === void 0 ? void 0 : _a.getValues(validation).data;
    }
    clear() {
        var _a;
        return ((_a = this.builderRef.current) === null || _a === void 0 ? void 0 : _a.clear()) || Promise.resolve();
    }
    validation() {
        var _a, _b;
        const validation = (_b = (_a = this.builderRef.current) === null || _a === void 0 ? void 0 : _a.getValues(true)) === null || _b === void 0 ? void 0 : _b.validation;
        return typeof (validation === null || validation === void 0 ? void 0 : validation.status) == "boolean" ? validation === null || validation === void 0 ? void 0 : validation.status : true;
    }
    render() {
        return (React__default["default"].createElement(FormBuilder, { inputs: this.props.inputs, ref: this.builderRef, onChange: this.onChangeValue }));
    }
}

class ItemsInput extends React.Component {
    constructor() {
        super(...arguments);
        this.state = {
            error: false,
            items: []
        };
        this.formBuilderRef = {};
        this.sleep = (ms) => {
            return new Promise(resolve => setTimeout(resolve, ms));
        };
        this.setItemValue = (key, object) => __awaiter(this, void 0, void 0, function* () {
            const formBuilderRef = this.formBuilderRef[key];
            if (!formBuilderRef) {
                yield this.sleep(5);
                return yield this.setItemValue(key, object);
            }
            return formBuilderRef.setValues(object);
        });
        this.exportFormBuilderData = () => {
            const values = [];
            for (const key in this.formBuilderRef) {
                const builder = this.formBuilderRef[key];
                if (builder) {
                    values.push(builder.getValues());
                }
            }
            return values;
        };
        this.getRandomKey = () => {
            const random = randomString(8);
            if (this.state.items.indexOf(random) > -1)
                return this.getRandomKey();
            return random;
        };
        this.addItem = () => {
            if (typeof (this.props.maxItems) === "number" && this.state.items.length >= this.props.maxItems)
                return Promise.resolve('');
            const random = this.getRandomKey();
            return new Promise((resolve) => {
                this.setState((oldState) => {
                    let state = Object.assign({}, oldState);
                    state.items = [...state.items, random];
                    return state;
                }, () => {
                    resolve(random);
                });
            });
        };
        this.copyItem = (key) => () => __awaiter(this, void 0, void 0, function* () {
            var _a;
            const newKey = yield this.addItem();
            const builder = this.formBuilderRef[key];
            if (builder) {
                const copyData = builder.getValues(false).data;
                (_a = this.formBuilderRef[newKey]) === null || _a === void 0 ? void 0 : _a.setValues(copyData);
            }
        });
        this.removeItem = (key) => () => __awaiter(this, void 0, void 0, function* () {
            if (typeof (this.props.minItems) === "number" && this.state.items.length <= this.props.minItems)
                return Promise.resolve();
            const formBuilderRef = this.formBuilderRef[key];
            if (formBuilderRef) {
                yield formBuilderRef.clear();
                this.setState((oldState) => {
                    let state = Object.assign({}, oldState);
                    state.items = state.items.filter(item => item !== key);
                    return state;
                }, () => {
                    delete this.formBuilderRef[key];
                });
            }
        });
        this.removeAll = () => {
            const items = [];
            [...Array(this.props.minItems).keys()].forEach(() => {
                const random = this.getRandomKey();
                items.push(random);
            });
            return this.setValue(items);
        };
        this.click = () => { };
        this.focus = () => { };
        this.blur = () => { };
        this.renderItem = (key) => {
            return (React__default["default"].createElement(material.Box, { key: key, display: "flex", alignItems: "center" },
                this.props.removeIcon !== false ? (React__default["default"].createElement(material.IconButton, { onClick: this.removeItem(key) }, this.props.removeIcon ? this.props.removeIcon : React__default["default"].createElement(iconsMaterial.Remove, null))) : null,
                React__default["default"].createElement(FormBuilder, { inputs: this.props.inputs, ref: el => this.formBuilderRef = Object.assign(Object.assign({}, this.formBuilderRef), { [key]: el }) }),
                this.props.copyIcon !== false ? (React__default["default"].createElement(material.IconButton, { onClick: this.copyItem(key) }, this.props.copyIcon ? this.props.copyIcon : React__default["default"].createElement(iconsMaterial.CopyAll, null))) : null));
        };
    }
    shouldComponentUpdate(_, nextState) {
        switch (true) {
            case JSON.stringify(this.state.items) !== JSON.stringify(nextState.items):
                return true;
            default: return false;
        }
    }
    UNSAFE_componentWillMount() {
        if (this.props.minItems && this.props.minItems > 0) {
            const items = [];
            [...Array(this.props.minItems).keys()].forEach(() => {
                const random = this.getRandomKey();
                items.push(random);
            });
            this.setState(Object.assign(Object.assign({}, this.state), { items }));
        }
    }
    setValue(values) {
        if (!values)
            values = [];
        return new Promise((resolve) => {
            this.setState(Object.assign(Object.assign({}, this.state), { items: [] }), () => __awaiter(this, void 0, void 0, function* () {
                const output = yield Promise.all(values.map((object) => __awaiter(this, void 0, void 0, function* () {
                    const key = yield this.addItem();
                    return this.setItemValue(key, object);
                })));
                resolve(output);
            }));
        });
    }
    getValue() {
        const items = this.exportFormBuilderData();
        return items.map(item => item.data);
    }
    clear() {
        return this.removeAll();
    }
    validation() {
        const data = this.exportFormBuilderData();
        return !data.some(datum => !(datum === null || datum === void 0 ? void 0 : datum.validation.status));
    }
    render() {
        return (React__default["default"].createElement(material.Box, null,
            this.props.renderHeader ? (this.props.renderHeader(this.addItem, this.removeAll)) : (React__default["default"].createElement(material.Box, null,
                React__default["default"].createElement(material.IconButton, { onClick: this.addItem },
                    React__default["default"].createElement(iconsMaterial.Add, null)),
                React__default["default"].createElement(material.IconButton, { onClick: this.removeAll },
                    React__default["default"].createElement(iconsMaterial.Delete, null)))),
            this.state.items.map((key) => this.props.itemWrapper
                ? this.props.itemWrapper(this.renderItem(key))
                : this.renderItem(key))));
    }
}

class MaskInput extends React.Component {
    constructor() {
        super(...arguments);
        this.state = {
            value: this.props.defaultValue || null,
            value_when_focus: this.props.defaultValue || null,
            error: false
        };
        this.onChange = (event) => {
            var _a, _b;
            let value = event.target.value;
            if (this.props.formatter && typeof this.props.formatter === "function") {
                const formattedValue = this.props.formatter(value);
                if (formattedValue !== undefined) {
                    value = formattedValue;
                }
            }
            this.normalizeValue(value);
            (_b = (_a = this.props).onChange) === null || _b === void 0 ? void 0 : _b.call(_a, event);
        };
        this.normalizeValue = (value) => __awaiter(this, void 0, void 0, function* () {
            if (!value) {
                this.setValue(null);
                return;
            }
            const pattern = this.props.pattern;
            const pureValue = value.replace(/[^0-9]/g, '');
            const maskedValues = mask(pureValue, pattern, this.props.char || '_');
            yield this.setValue(pureValue ? maskedValues : null, true);
            const valueForLength = maskedValues.match(/.*[0-9]/);
            if (this.inputRef && valueForLength) {
                this.inputRef.selectionStart = this.inputRef.selectionEnd = valueForLength[0].length;
            }
        });
        this.onClick = (event) => {
            var _a, _b;
            clearTimeout(this.validationTimeout);
            if (this.state.error) {
                this.setState(Object.assign(Object.assign({}, this.state), { error: false }));
            }
            (_b = (_a = this.props).onClick) === null || _b === void 0 ? void 0 : _b.call(_a, event);
        };
        this.onBlur = (e) => {
            var _a, _b, _c, _d;
            const value = e.target.value || null;
            if (value !== this.state.value_when_focus) {
                (_b = (_a = this.props)._call_parent_for_update) === null || _b === void 0 ? void 0 : _b.call(_a);
            }
            (_d = (_c = this.props).onBlur) === null || _d === void 0 ? void 0 : _d.call(_c, e);
        };
        this.onFocus = (e) => {
            var _a, _b;
            const value_when_focus = e.target.value || null;
            if (this.state.value_when_focus !== value_when_focus)
                this.setState(Object.assign(Object.assign({}, this.state), { value_when_focus }));
            (_b = (_a = this.props).onFocus) === null || _b === void 0 ? void 0 : _b.call(_a, e);
        };
        this.click = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.click();
        };
        this.focus = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.focus();
        };
        this.blur = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.blur();
        };
    }
    shouldComponentUpdate(nextProps, nextState) {
        switch (true) {
            case this.state.value !== nextState.value:
            case this.state.error !== nextState.error:
            case this.props.label !== nextProps.label:
            case this.props.pattern !== nextProps.pattern:
            case this.props.char !== nextProps.char:
            case this.props.disabled !== nextProps.disabled:
                return true;
            default: return false;
        }
    }
    setValue(value, withoutEffect) {
        if (value === this.state.value)
            return Promise.resolve(value);
        return new Promise((resolve) => {
            this.setState(Object.assign(Object.assign({}, this.state), { value }), () => {
                var _a, _b, _c, _d;
                if (!withoutEffect)
                    (_b = (_a = this.props)._call_parent_for_update) === null || _b === void 0 ? void 0 : _b.call(_a);
                (_d = (_c = this.props).onChangeValue) === null || _d === void 0 ? void 0 : _d.call(_c, value);
                resolve(value);
            });
        });
    }
    getValue() {
        return this.state.value || null;
    }
    clear() {
        return this.setValue(this.props.defaultValue || null);
    }
    validation() {
        if (!this.state.value && this.props.required) {
            clearTimeout(this.validationTimeout);
            this.setState(Object.assign(Object.assign({}, this.state), { error: true }));
            this.validationTimeout = setTimeout(() => {
                this.setState(Object.assign(Object.assign({}, this.state), { error: false }));
            }, 3000);
            return false;
        }
        return true;
    }
    render() {
        const _a = this.props, restProps = __rest(_a, ["onChangeValue", "formatter", "visible", "_call_parent_for_update", "defaultValue"]);
        return React__default["default"].createElement(TextField__default["default"], Object.assign({}, restProps, { variant: this.props.variant || "standard", error: this.state.error, onChange: this.onChange, onClick: this.onClick, onBlur: this.onBlur, onFocus: this.onFocus, value: this.state.value || '', inputRef: el => this.inputRef = el }));
    }
}

var img$2 = "data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' id='flag-icons-ae' viewBox='0 0 640 480'%3e %3cpath fill='%2300732f' d='M0 0h640v160H0z'/%3e %3cpath fill='white' d='M0 160h640v160H0z'/%3e %3cpath d='M0 320h640v160H0z'/%3e %3cpath fill='red' d='M0 0h220v480H0z'/%3e%3c/svg%3e";

var img$1 = "data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' id='flag-icons-ir' viewBox='0 0 640 480'%3e %3cdefs%3e %3cclipPath id='a'%3e %3cpath fill-opacity='.7' d='M-85.3 0h682.7v512H-85.3z'/%3e %3c/clipPath%3e %3c/defs%3e %3cg fill-rule='evenodd' clip-path='url(%23a)' transform='translate(80) scale(.9375)'%3e %3cpath fill='white' d='M-192 0h896v512h-896z'/%3e %3cpath fill='%23da0000' d='M-192 343.8h896V512h-896z'/%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M-21.6 351h49v3.3h-49zm7.3 16.8h3.4v3.3h-3.4zm41.9 0v3.3h-9.8v-3.4zm5.2-16.8h3.4v20h-3.4z'/%3e %3cpath d='M52.4 367.7v3.4H33.8v-3.4zm-34.6-7.9H21v11.3h-3.3z'/%3e %3cpath d='M49.6 351H53v20h-3.4zm-8.4 0h3.3v20h-3.3zm-44.8 8v3.4h-18V359zm39.3 0v3.4h-18V359z'/%3e %3cpath d='M17.8 359.9H21V371h-3.3z'/%3e %3cpath d='M17.8 359.9H21V371h-3.3z'/%3e %3cpath d='M17.8 359.9H21V371h-3.3zm-39.3 0h3.3V371h-3.3zm28.8 0h3.4V371H7.3zm-14.3 0h3.4V371H-7z'/%3e %3cpath d='M9.6 367.7v3.4H-5.5v-3.4zm1-8.7v3.4H1V359z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M-102.2 351h49v3.3h-49zm7.3 16.8h3.4v3.3H-95zm41.9 0v3.3h-9.8v-3.4zm5.2-16.8h3.4v20h-3.4z'/%3e %3cpath d='M-28.2 367.7v3.4h-18.6v-3.4zm-34.6-7.9h3.3v11.3h-3.3z'/%3e %3cpath d='M-31 351h3.4v20H-31zm-8.4 0h3.3v20h-3.3zm-44.8 8v3.4h-18V359zm39.3 0v3.4h-18V359z'/%3e %3cpath d='M-62.8 359.9h3.3V371h-3.3z'/%3e %3cpath d='M-62.8 359.9h3.3V371h-3.3z'/%3e %3cpath d='M-62.8 359.9h3.3V371h-3.3zm-39.3 0h3.3V371h-3.3zm28.8 0h3.3V371h-3.3zm-14.3 0h3.4V371h-3.4z'/%3e %3cpath d='M-71 367.7v3.4h-15v-3.4zm1-8.7v3.4h-9.6V359z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M58.3 351h49v3.3h-49zm7.3 16.8H69v3.3h-3.4zm41.9 0v3.3h-9.8v-3.4zm5.3-16.8h3.4v20h-3.4z'/%3e %3cpath d='M132.3 367.7v3.4h-18.6v-3.4zm-34.6-7.9h3.4v11.3h-3.4z'/%3e %3cpath d='M129.5 351h3.4v20h-3.4zm-8.4 0h3.4v20H121zm-44.8 8v3.4h-18V359zm39.3 0v3.4h-18V359z'/%3e %3cpath d='M97.7 359.9h3.4V371h-3.4z'/%3e %3cpath d='M97.7 359.9h3.4V371h-3.4z'/%3e %3cpath d='M97.7 359.9h3.4V371h-3.4zm-39.3 0h3.4V371h-3.4zm28.8 0h3.4V371h-3.4zm-14.3 0h3.4V371h-3.4z'/%3e %3cpath d='M89.6 367.7v3.4H74.4v-3.4zm1-8.7v3.4H81V359z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M622.7 351h49v3.3h-49zm7.3 16.8h3.4v3.3H630zm41.9 0v3.3H662v-3.4zm5.3-16.8h3.3v20h-3.4z'/%3e %3cpath d='M696.7 367.7v3.4H678v-3.4zm-34.6-7.9h3.4v11.3H662z'/%3e %3cpath d='M694 351h3.3v20h-3.4zm-8.5 0h3.4v20h-3.4zm-44.8 8v3.4h-18V359zm39.3 0v3.4h-18V359z'/%3e %3cpath d='M662 359.9h3.5V371H662z'/%3e %3cpath d='M662 359.9h3.5V371H662z'/%3e %3cpath d='M662 359.9h3.5V371H662zm-39.2 0h3.4V371h-3.4zm28.8 0h3.4V371h-3.4zm-14.3 0h3.4V371h-3.4z'/%3e %3cpath d='M654 367.7v3.4h-15.2v-3.4zm1-8.7v3.4h-9.6V359z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M138.7 351h49.1v3.3h-49zm7.4 16.8h3.3v3.3h-3.3zm41.8 0v3.3h-9.8v-3.4zm5.3-16.8h3.4v20h-3.4z'/%3e %3cpath d='M212.8 367.7v3.4h-18.6v-3.4zm-34.7-7.9h3.4v11.3h-3.4z'/%3e %3cpath d='M210 351h3.4v20H210zm-8.5 0h3.4v20h-3.4zm-44.8 8v3.4h-17.9V359zm39.3 0v3.4h-17.9V359z'/%3e %3cpath d='M178.1 359.9h3.4V371h-3.4z'/%3e %3cpath d='M178.1 359.9h3.4V371h-3.4z'/%3e %3cpath d='M178.1 359.9h3.4V371h-3.4zm-39.3 0h3.4V371h-3.4zm28.8 0h3.4V371h-3.4zm-14.2 0h3.3V371h-3.3z'/%3e %3cpath d='M170 367.7v3.4h-15.1v-3.4zm1-8.7v3.4h-9.6V359z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M219.5 351h49v3.3h-49zm7.3 16.8h3.4v3.3h-3.4zm41.9 0v3.3h-9.8v-3.4zM274 351h3.3v20H274z'/%3e %3cpath d='M293.5 367.7v3.4h-18.6v-3.4zm-34.6-7.9h3.4v11.3h-3.4z'/%3e %3cpath d='M290.7 351h3.4v20h-3.4zm-8.4 0h3.4v20h-3.4zm-44.8 8v3.4h-18V359zm39.3 0v3.4h-18V359z'/%3e %3cpath d='M258.9 359.9h3.4V371h-3.4z'/%3e %3cpath d='M258.9 359.9h3.4V371h-3.4z'/%3e %3cpath d='M258.9 359.9h3.4V371h-3.4zm-39.3 0h3.3V371h-3.3zm28.8 0h3.4V371h-3.4zm-14.3 0h3.4V371H234z'/%3e %3cpath d='M250.8 367.7v3.4h-15.2v-3.4zm1-8.7v3.4H242V359z'/%3e %3c/g%3e %3cpath fill='%23239f40' d='M-192 0h896v168.2h-896z'/%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M300.7 351h49v3.3h-49zm7.3 16.8h3.4v3.3H308zm41.9 0v3.3H340v-3.4zm5.3-16.8h3.3v20h-3.3z'/%3e %3cpath d='M374.7 367.7v3.4h-18.6v-3.4zm-34.6-7.9h3.4v11.3H340z'/%3e %3cpath d='M372 351h3.3v20H372zm-8.5 0h3.4v20h-3.4zm-44.8 8v3.4h-18V359zm39.3 0v3.4h-18V359z'/%3e %3cpath d='M340 359.9h3.5V371H340z'/%3e %3cpath d='M340 359.9h3.5V371H340z'/%3e %3cpath d='M340 359.9h3.5V371H340zm-39.2 0h3.4V371h-3.4zm28.8 0h3.4V371h-3.4zm-14.3 0h3.4V371h-3.4z'/%3e %3cpath d='M332 367.7v3.4h-15.2v-3.4zm1-8.7v3.4h-9.6V359z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M381.4 351h49v3.3h-49zm7.3 16.8h3.4v3.3h-3.4zm42 0v3.3h-9.9v-3.4zm5.2-16.8h3.4v20h-3.4z'/%3e %3cpath d='M455.4 367.7v3.4h-18.6v-3.4zm-34.6-7.9h3.4v11.3h-3.4z'/%3e %3cpath d='M452.7 351h3.3v20h-3.3zm-8.5 0h3.4v20h-3.4zm-44.8 8v3.4h-17.9V359zm39.3 0v3.4h-17.9V359z'/%3e %3cpath d='M420.8 359.9h3.4V371h-3.4z'/%3e %3cpath d='M420.8 359.9h3.4V371h-3.4z'/%3e %3cpath d='M420.8 359.9h3.4V371h-3.4zm-39.3 0h3.4V371h-3.4zm28.8 0h3.4V371h-3.4zm-14.3 0h3.4V371h-3.3z'/%3e %3cpath d='M412.7 367.7v3.4h-15.1v-3.4zm1-8.7v3.4H404V359z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M462.2 351h49v3.3h-49zm7.3 16.8h3.4v3.3h-3.4zm41.9 0v3.3h-9.8v-3.4zm5.2-16.8h3.4v20h-3.4z'/%3e %3cpath d='M536.2 367.7v3.4h-18.6v-3.4zm-34.7-7.9h3.4v11.3h-3.4z'/%3e %3cpath d='M533.4 351h3.4v20h-3.4zm-8.4 0h3.3v20H525zm-44.8 8v3.4h-18V359zm39.3 0v3.4h-18V359z'/%3e %3cpath d='M501.6 359.9h3.3V371h-3.3z'/%3e %3cpath d='M501.6 359.9h3.3V371h-3.3z'/%3e %3cpath d='M501.6 359.9h3.3V371h-3.3zm-39.4 0h3.4V371h-3.4zm28.9 0h3.3V371h-3.3zm-14.3 0h3.4V371h-3.4z'/%3e %3cpath d='M493.4 367.7v3.4h-15.1v-3.4zm1-8.7v3.4h-9.6V359z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M543.4 351h49v3.3h-49zm7.3 16.8h3.4v3.3h-3.4zm41.9 0v3.3h-9.8v-3.4zm5.2-16.8h3.4v20h-3.4z'/%3e %3cpath d='M617.4 367.7v3.4h-18.6v-3.4zm-34.6-7.9h3.3v11.3h-3.3z'/%3e %3cpath d='M614.6 351h3.4v20h-3.4zm-8.4 0h3.3v20h-3.3zm-44.8 8v3.4h-18V359zm39.3 0v3.4h-18V359z'/%3e %3cpath d='M582.8 359.9h3.3V371h-3.3z'/%3e %3cpath d='M582.8 359.9h3.3V371h-3.3z'/%3e %3cpath d='M582.8 359.9h3.3V371h-3.3zm-39.3 0h3.3V371h-3.3zm28.8 0h3.4V371h-3.4zm-14.3 0h3.4V371H558z'/%3e %3cpath d='M574.6 367.7v3.4h-15.1v-3.4zm1-8.7v3.4H566V359z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M-183.8 351h49v3.3h-49zm7.3 16.8h3.4v3.3h-3.4zm42 0v3.3h-9.9v-3.4zm5.2-16.8h3.4v20h-3.4z'/%3e %3cpath d='M-109.8 367.7v3.4h-18.6v-3.4zm-34.6-7.9h3.4v11.3h-3.4z'/%3e %3cpath d='M-112.5 351h3.3v20h-3.3zm-8.5 0h3.4v20h-3.4zm-44.8 8v3.4h-17.9V359zm39.3 0v3.4h-17.9V359z'/%3e %3cpath d='M-144.4 359.9h3.4V371h-3.4z'/%3e %3cpath d='M-144.4 359.9h3.4V371h-3.4z'/%3e %3cpath d='M-144.4 359.9h3.4V371h-3.4zm-39.3 0h3.4V371h-3.4zm28.8 0h3.4V371h-3.4zm-14.3 0h3.4V371h-3.4z'/%3e %3cpath d='M-152.5 367.7v3.4h-15.2v-3.4zm1-8.7v3.4h-9.6V359z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M-21.6 143.4h49v3.4h-49zm7.3 17h3.4v3.2h-3.4zm41.9-.2v3.4h-9.8v-3.4zm5.2-16.8h3.4v20.2h-3.4z'/%3e %3cpath d='M52.4 160.2v3.4H33.8v-3.4zm-34.6-7.9H21v11.3h-3.3z'/%3e %3cpath d='M49.6 143.4H53v20.2h-3.4zm-8.4 0h3.3v20.2h-3.3zm-44.8 8v3.4h-18v-3.3zm39.3 0v3.4h-18v-3.3z'/%3e %3cpath d='M17.8 152.3H21v11.3h-3.3z'/%3e %3cpath d='M17.8 152.3H21v11.3h-3.3z'/%3e %3cpath d='M17.8 152.3H21v11.3h-3.3zm-39.3 0h3.3v11.3h-3.3zm28.8 0h3.4v11.3H7.3zm-14.3 0h3.4v11.3H-7z'/%3e %3cpath d='M9.6 160.2v3.4H-5.5v-3.4zm1-8.7v3.3H1v-3.3z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M-102.2 143.4h49v3.4h-49zm7.3 17h3.4v3.2H-95zm41.9-.2v3.4h-9.8v-3.4zm5.2-16.8h3.4v20.2h-3.4z'/%3e %3cpath d='M-28.2 160.2v3.4h-18.6v-3.4zm-34.6-7.9h3.3v11.3h-3.3z'/%3e %3cpath d='M-31 143.4h3.4v20.2H-31zm-8.4 0h3.3v20.2h-3.3zm-44.8 8v3.4h-18v-3.3zm39.3 0v3.4h-18v-3.3z'/%3e %3cpath d='M-62.8 152.3h3.3v11.3h-3.3z'/%3e %3cpath d='M-62.8 152.3h3.3v11.3h-3.3z'/%3e %3cpath d='M-62.8 152.3h3.3v11.3h-3.3zm-39.3 0h3.3v11.3h-3.3zm28.8 0h3.3v11.3h-3.3zm-14.3 0h3.4v11.3h-3.4z'/%3e %3cpath d='M-71 160.2v3.4h-15v-3.4zm1-8.7v3.3h-9.6v-3.3z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M58.3 143.4h49v3.4h-49zm7.3 17H69v3.2h-3.4zm41.9-.2v3.4h-9.8v-3.4zm5.3-16.8h3.4v20.2h-3.4z'/%3e %3cpath d='M132.3 160.2v3.4h-18.6v-3.4zm-34.6-7.9h3.4v11.3h-3.4z'/%3e %3cpath d='M129.5 143.4h3.4v20.2h-3.4zm-8.4 0h3.4v20.2H121zm-44.8 8v3.4h-18v-3.3zm39.3 0v3.4h-18v-3.3z'/%3e %3cpath d='M97.7 152.3h3.4v11.3h-3.4z'/%3e %3cpath d='M97.7 152.3h3.4v11.3h-3.4z'/%3e %3cpath d='M97.7 152.3h3.4v11.3h-3.4zm-39.3 0h3.4v11.3h-3.4zm28.8 0h3.4v11.3h-3.4zm-14.3 0h3.4v11.3h-3.4z'/%3e %3cpath d='M89.6 160.2v3.4H74.4v-3.4zm1-8.7v3.3H81v-3.3z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M622.7 143.4h49v3.4h-49zm7.3 17h3.4v3.2H630zm41.9-.2v3.4H662v-3.4zm5.3-16.8h3.3v20.2h-3.4z'/%3e %3cpath d='M696.7 160.2v3.4H678v-3.4zm-34.6-7.9h3.4v11.3H662z'/%3e %3cpath d='M694 143.4h3.3v20.2h-3.4zm-8.5 0h3.4v20.2h-3.4zm-44.8 8v3.4h-18v-3.3zm39.3 0v3.4h-18v-3.3z'/%3e %3cpath d='M662 152.3h3.5v11.3H662z'/%3e %3cpath d='M662 152.3h3.5v11.3H662z'/%3e %3cpath d='M662 152.3h3.5v11.3H662zm-39.2 0h3.4v11.3h-3.4zm28.8 0h3.4v11.3h-3.4zm-14.3 0h3.4v11.3h-3.4z'/%3e %3cpath d='M654 160.2v3.4h-15.2v-3.4zm1-8.7v3.3h-9.6v-3.3z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M138.7 143.4h49.1v3.4h-49zm7.4 17h3.3v3.2h-3.3zm41.8-.2v3.4h-9.8v-3.4zm5.3-16.8h3.4v20.2h-3.4z'/%3e %3cpath d='M212.8 160.2v3.4h-18.6v-3.4zm-34.7-7.9h3.4v11.3h-3.4z'/%3e %3cpath d='M210 143.4h3.4v20.2H210zm-8.5 0h3.4v20.2h-3.4zm-44.8 8v3.4h-17.9v-3.3zm39.3 0v3.4h-17.9v-3.3z'/%3e %3cpath d='M178.1 152.3h3.4v11.3h-3.4z'/%3e %3cpath d='M178.1 152.3h3.4v11.3h-3.4z'/%3e %3cpath d='M178.1 152.3h3.4v11.3h-3.4zm-39.3 0h3.4v11.3h-3.4zm28.8 0h3.4v11.3h-3.4zm-14.2 0h3.3v11.3h-3.3z'/%3e %3cpath d='M170 160.2v3.4h-15.1v-3.4zm1-8.7v3.3h-9.6v-3.3z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M219.5 143.4h49v3.4h-49zm7.3 17h3.4v3.2h-3.4zm41.9-.2v3.4h-9.8v-3.4zm5.3-16.8h3.3v20.2H274z'/%3e %3cpath d='M293.5 160.2v3.4h-18.6v-3.4zm-34.6-7.9h3.4v11.3h-3.4z'/%3e %3cpath d='M290.7 143.4h3.4v20.2h-3.4zm-8.4 0h3.4v20.2h-3.4zm-44.8 8v3.4h-18v-3.3zm39.3 0v3.4h-18v-3.3z'/%3e %3cpath d='M258.9 152.3h3.4v11.3h-3.4z'/%3e %3cpath d='M258.9 152.3h3.4v11.3h-3.4z'/%3e %3cpath d='M258.9 152.3h3.4v11.3h-3.4zm-39.3 0h3.3v11.3h-3.3zm28.8 0h3.4v11.3h-3.4zm-14.3 0h3.4v11.3H234z'/%3e %3cpath d='M250.8 160.2v3.4h-15.2v-3.4zm1-8.7v3.3H242v-3.3z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M300.7 143.4h49v3.4h-49zm7.3 17h3.4v3.2H308zm41.9-.2v3.4H340v-3.4zm5.3-16.8h3.3v20.2h-3.3z'/%3e %3cpath d='M374.7 160.2v3.4h-18.6v-3.4zm-34.6-7.9h3.4v11.3H340z'/%3e %3cpath d='M372 143.4h3.3v20.2H372zm-8.5 0h3.4v20.2h-3.4zm-44.8 8v3.4h-18v-3.3zm39.3 0v3.4h-18v-3.3z'/%3e %3cpath d='M340 152.3h3.5v11.3H340z'/%3e %3cpath d='M340 152.3h3.5v11.3H340z'/%3e %3cpath d='M340 152.3h3.5v11.3H340zm-39.2 0h3.4v11.3h-3.4zm28.8 0h3.4v11.3h-3.4zm-14.3 0h3.4v11.3h-3.4z'/%3e %3cpath d='M332 160.2v3.4h-15.2v-3.4zm1-8.7v3.3h-9.6v-3.3z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M381.4 143.4h49v3.4h-49zm7.3 17h3.4v3.2h-3.4zm42-.2v3.4h-9.9v-3.4zm5.2-16.8h3.4v20.2h-3.4z'/%3e %3cpath d='M455.4 160.2v3.4h-18.6v-3.4zm-34.6-7.9h3.4v11.3h-3.4z'/%3e %3cpath d='M452.7 143.4h3.3v20.2h-3.3zm-8.5 0h3.4v20.2h-3.4zm-44.8 8v3.4h-17.9v-3.3zm39.3 0v3.4h-17.9v-3.3z'/%3e %3cpath d='M420.8 152.3h3.4v11.3h-3.4z'/%3e %3cpath d='M420.8 152.3h3.4v11.3h-3.4z'/%3e %3cpath d='M420.8 152.3h3.4v11.3h-3.4zm-39.3 0h3.4v11.3h-3.4zm28.8 0h3.4v11.3h-3.4zm-14.3 0h3.4v11.3h-3.3z'/%3e %3cpath d='M412.7 160.2v3.4h-15.1v-3.4zm1-8.7v3.3H404v-3.3z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M462.2 143.4h49v3.4h-49zm7.3 17h3.4v3.2h-3.4zm41.9-.2v3.4h-9.8v-3.4zm5.2-16.8h3.4v20.2h-3.4z'/%3e %3cpath d='M536.2 160.2v3.4h-18.6v-3.4zm-34.7-7.9h3.4v11.3h-3.4z'/%3e %3cpath d='M533.4 143.4h3.4v20.2h-3.4zm-8.4 0h3.3v20.2H525zm-44.8 8v3.4h-18v-3.3zm39.3 0v3.4h-18v-3.3z'/%3e %3cpath d='M501.6 152.3h3.3v11.3h-3.3z'/%3e %3cpath d='M501.6 152.3h3.3v11.3h-3.3z'/%3e %3cpath d='M501.6 152.3h3.3v11.3h-3.3zm-39.4 0h3.4v11.3h-3.4zm28.9 0h3.3v11.3h-3.3zm-14.3 0h3.4v11.3h-3.4z'/%3e %3cpath d='M493.4 160.2v3.4h-15.1v-3.4zm1-8.7v3.3h-9.6v-3.3z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M543.4 143.4h49v3.4h-49zm7.3 17h3.4v3.2h-3.4zm41.9-.2v3.4h-9.8v-3.4zm5.2-16.8h3.4v20.2h-3.4z'/%3e %3cpath d='M617.4 160.2v3.4h-18.6v-3.4zm-34.6-7.9h3.3v11.3h-3.3z'/%3e %3cpath d='M614.6 143.4h3.4v20.2h-3.4zm-8.4 0h3.3v20.2h-3.3zm-44.8 8v3.4h-18v-3.3zm39.3 0v3.4h-18v-3.3z'/%3e %3cpath d='M582.8 152.3h3.3v11.3h-3.3z'/%3e %3cpath d='M582.8 152.3h3.3v11.3h-3.3z'/%3e %3cpath d='M582.8 152.3h3.3v11.3h-3.3zm-39.3 0h3.3v11.3h-3.3zm28.8 0h3.4v11.3h-3.4zm-14.3 0h3.4v11.3H558z'/%3e %3cpath d='M574.6 160.2v3.4h-15.1v-3.4zm1-8.7v3.3H566v-3.3z'/%3e %3c/g%3e %3cg fill='white' stroke-width='1pt'%3e %3cpath d='M-183.8 143.4h49v3.4h-49zm7.3 17h3.4v3.2h-3.4zm42-.2v3.4h-9.9v-3.4zm5.2-16.8h3.4v20.2h-3.4z'/%3e %3cpath d='M-109.8 160.2v3.4h-18.6v-3.4zm-34.6-7.9h3.4v11.3h-3.4z'/%3e %3cpath d='M-112.5 143.4h3.3v20.2h-3.3zm-8.5 0h3.4v20.2h-3.4zm-44.8 8v3.4h-17.9v-3.3zm39.3 0v3.4h-17.9v-3.3z'/%3e %3cpath d='M-144.4 152.3h3.4v11.3h-3.4z'/%3e %3cpath d='M-144.4 152.3h3.4v11.3h-3.4z'/%3e %3cpath d='M-144.4 152.3h3.4v11.3h-3.4zm-39.3 0h3.4v11.3h-3.4zm28.8 0h3.4v11.3h-3.4zm-14.3 0h3.4v11.3h-3.4z'/%3e %3cpath d='M-152.5 160.2v3.4h-15.2v-3.4zm1-8.7v3.3h-9.6v-3.3z'/%3e %3c/g%3e %3cpath fill='%23d90000' d='M-68.8 339.5h6V350h-6zm160.5 0h6V350h-6zm-283.7 0h6V350h-6zm81.5 0h6V350h-6zm80.9 0h6V350h-6zm40 0h6V350h-6zm40.9 0h6V350h-6zm80.4 0h6V350h-6zm203 0h6.1V350h-6zm-162.1 0h6V350h-6zm40 0h6V350h-6zm40.5 0h6V350h-6zm40.4 0h6V350h-6zm323.2 0h6V350h-6zm-242.7 0h6V350h-6zm40.8 0h6V350h-6zm41.3 0h6V350h-6zm38.8 0h6V350h-6zm41.3 0h6V350h-6zm40.4 0h6V350h-6zm119.7 0h6V350h-6zm-38.8 0h6V350h-6zm-808.9 0h6V350h-6z'/%3e %3cpath fill='%23239e3f' d='M-68.8 162.6h6v10.5h-6zm160.5 0h6v10.5h-6zm-283.7 0h6v10.5h-6zm81.5 0h6v10.5h-6zm80.9 0h6v10.5h-6zm40 0h6v10.5h-6zm40.9 0h6v10.5h-6zm80.4 0h6v10.5h-6zm203 0h6.1v10.5h-6zm-162.1 0h6v10.5h-6zm40 0h6v10.5h-6zm40.5 0h6v10.5h-6zm40.4 0h6v10.5h-6zm323.2 0h6v10.5h-6zm-242.7 0h6v10.5h-6zm40.8 0h6v10.5h-6zm41.3 0h6v10.5h-6zm38.8 0h6v10.5h-6zm41.3 0h6v10.5h-6zm40.4 0h6v10.5h-6zm119.7 0h6v10.5h-6zm-38.8 0h6v10.5h-6zm-808.9 0h6v10.5h-6z'/%3e %3cg fill='%23da0000'%3e %3cpath d='M279.8 197.5c8.4 10.4 34.5 67.6-15.7 105.2-23.7 17.8-9 18.6-8.3 21.6 38-20.1 50.3-47.5 50-72-.2-24.4-13.2-46-26-54.8z'/%3e %3cpath d='M284.8 194.8a73.3 73.3 0 0 1 15.7 112.4c27.2-6 62-86.4-15.7-112.4zm-57.6 0a73.3 73.3 0 0 0-15.6 112.4c-27.3-6-62-86.4 15.6-112.4z'/%3e %3cpath d='M232.2 197.5c-8.4 10.4-34.5 67.6 15.7 105.2 23.6 17.8 9 18.6 8.3 21.6-38-20.1-50.3-47.5-50-72 .2-24.4 13.2-46 26-54.8z'/%3e %3cpath d='M304.2 319.1c-14.9.2-33.6-2-47.5-9.3 2.3 4.5 4.2 7.3 6.5 11.7 13.2 1.3 31.5 2.8 41-2.4zm-95 0c14.9.2 33.6-2 47.5-9.3-2.3 4.5-4.2 7.3-6.5 11.7-13.2 1.3-31.5 2.8-41-2.4zm27.3-138.7c3 8 10.9 9.2 19.3 4.5 6.2 3.6 15.7 3.9 19-4.1 2.5 19.8-18.3 15-19 11.2-7.8 7.5-22.2 3.2-19.3-11.6z'/%3e %3cpath d='m256.4 331.6 7.8-9 1.1-120.1-9.3-8.2-9.3 7.8 1.9 121 7.8 8.5z'/%3e %3c/g%3e %3c/g%3e%3c/svg%3e";

var img = "data:image/svg+xml,%3csvg xmlns='http://www.w3.org/2000/svg' id='flag-icons-us' viewBox='0 0 640 480'%3e %3cg fill-rule='evenodd'%3e %3cg stroke-width='1pt'%3e %3cpath fill='%23bd3d44' d='M0 0h912v37H0zm0 73.9h912v37H0zm0 73.8h912v37H0zm0 73.8h912v37H0zm0 74h912v36.8H0zm0 73.7h912v37H0zM0 443h912V480H0z'/%3e %3cpath fill='white' d='M0 37h912v36.9H0zm0 73.8h912v36.9H0zm0 73.8h912v37H0zm0 73.9h912v37H0zm0 73.8h912v37H0zm0 73.8h912v37H0z'/%3e %3c/g%3e %3cpath fill='%23192f5d' d='M0 0h364.8v258.5H0z'/%3e %3cpath fill='white' d='m30.4 11 3.4 10.3h10.6l-8.6 6.3 3.3 10.3-8.7-6.4-8.6 6.3L25 27.6l-8.7-6.3h10.9zm60.8 0 3.3 10.3h10.8l-8.7 6.3 3.2 10.3-8.6-6.4-8.7 6.3 3.3-10.2-8.6-6.3h10.6zm60.8 0 3.3 10.3H166l-8.6 6.3 3.3 10.3-8.7-6.4-8.7 6.3 3.3-10.2-8.7-6.3h10.8zm60.8 0 3.3 10.3h10.8l-8.7 6.3 3.3 10.3-8.7-6.4-8.7 6.3 3.4-10.2-8.8-6.3h10.7zm60.8 0 3.3 10.3h10.7l-8.6 6.3 3.3 10.3-8.7-6.4-8.7 6.3 3.3-10.2-8.6-6.3h10.7zm60.8 0 3.3 10.3h10.8l-8.8 6.3 3.4 10.3-8.7-6.4-8.7 6.3 3.4-10.2-8.8-6.3h10.8zM60.8 37l3.3 10.2H75l-8.7 6.2 3.2 10.3-8.5-6.3-8.7 6.3 3.1-10.3-8.4-6.2h10.7zm60.8 0 3.4 10.2h10.7l-8.8 6.2 3.4 10.3-8.7-6.3-8.7 6.3 3.3-10.3-8.7-6.2h10.8zm60.8 0 3.3 10.2h10.8l-8.7 6.2 3.3 10.3-8.7-6.3-8.7 6.3 3.3-10.3-8.6-6.2H179zm60.8 0 3.4 10.2h10.7l-8.8 6.2 3.4 10.3-8.7-6.3-8.6 6.3 3.2-10.3-8.7-6.2H240zm60.8 0 3.3 10.2h10.8l-8.7 6.2 3.3 10.3-8.7-6.3-8.7 6.3 3.3-10.3-8.6-6.2h10.7zM30.4 62.6l3.4 10.4h10.6l-8.6 6.3 3.3 10.2-8.7-6.3-8.6 6.3L25 79.3 16.3 73h10.9zm60.8 0L94.5 73h10.8l-8.7 6.3 3.2 10.2-8.6-6.3-8.7 6.3 3.3-10.3-8.6-6.3h10.6zm60.8 0 3.3 10.3H166l-8.6 6.3 3.3 10.2-8.7-6.3-8.7 6.3 3.3-10.3-8.7-6.3h10.8zm60.8 0 3.3 10.3h10.8l-8.7 6.3 3.3 10.2-8.7-6.3-8.7 6.3 3.4-10.3-8.8-6.3h10.7zm60.8 0 3.3 10.3h10.7l-8.6 6.3 3.3 10.2-8.7-6.3-8.7 6.3 3.3-10.3-8.6-6.3h10.7zm60.8 0 3.3 10.3h10.8l-8.8 6.3 3.4 10.2-8.7-6.3-8.7 6.3 3.4-10.3-8.8-6.3h10.8zM60.8 88.6l3.3 10.2H75l-8.7 6.3 3.3 10.3-8.7-6.4-8.7 6.3 3.3-10.2-8.6-6.3h10.7zm60.8 0 3.4 10.2h10.7l-8.8 6.3 3.4 10.3-8.7-6.4-8.7 6.3 3.3-10.2-8.7-6.3h10.8zm60.8 0 3.3 10.2h10.8l-8.7 6.3 3.3 10.3-8.7-6.4-8.7 6.3 3.3-10.2-8.6-6.3H179zm60.8 0 3.4 10.2h10.7l-8.7 6.3 3.3 10.3-8.7-6.4-8.6 6.3 3.2-10.2-8.7-6.3H240zm60.8 0 3.3 10.2h10.8l-8.7 6.3 3.3 10.3-8.7-6.4-8.7 6.3 3.3-10.2-8.6-6.3h10.7zM30.4 114.5l3.4 10.2h10.6l-8.6 6.3 3.3 10.3-8.7-6.4-8.6 6.3L25 131l-8.7-6.3h10.9zm60.8 0 3.3 10.2h10.8l-8.7 6.3 3.2 10.2-8.6-6.3-8.7 6.3 3.3-10.2-8.6-6.3h10.6zm60.8 0 3.3 10.2H166l-8.6 6.3 3.3 10.3-8.7-6.4-8.7 6.3 3.3-10.2-8.7-6.3h10.8zm60.8 0 3.3 10.2h10.8l-8.7 6.3 3.3 10.3-8.7-6.4-8.7 6.3 3.4-10.2-8.8-6.3h10.7zm60.8 0 3.3 10.2h10.7L279 131l3.3 10.3-8.7-6.4-8.7 6.3 3.3-10.2-8.6-6.3h10.7zm60.8 0 3.3 10.2h10.8l-8.8 6.3 3.4 10.3-8.7-6.4-8.7 6.3L329 131l-8.8-6.3h10.8zM60.8 140.3l3.3 10.3H75l-8.7 6.2 3.3 10.3-8.7-6.4-8.7 6.4 3.3-10.3-8.6-6.3h10.7zm60.8 0 3.4 10.3h10.7l-8.8 6.2 3.4 10.3-8.7-6.4-8.7 6.4 3.3-10.3-8.7-6.3h10.8zm60.8 0 3.3 10.3h10.8l-8.7 6.2 3.3 10.3-8.7-6.4-8.7 6.4 3.3-10.3-8.6-6.3H179zm60.8 0 3.4 10.3h10.7l-8.7 6.2 3.3 10.3-8.7-6.4-8.6 6.4 3.2-10.3-8.7-6.3H240zm60.8 0 3.3 10.3h10.8l-8.7 6.2 3.3 10.3-8.7-6.4-8.7 6.4 3.3-10.3-8.6-6.3h10.7zM30.4 166.1l3.4 10.3h10.6l-8.6 6.3 3.3 10.1-8.7-6.2-8.6 6.2 3.2-10.2-8.7-6.3h10.9zm60.8 0 3.3 10.3h10.8l-8.7 6.3 3.3 10.1-8.7-6.2-8.7 6.2 3.4-10.2-8.7-6.3h10.6zm60.8 0 3.3 10.3H166l-8.6 6.3 3.3 10.1-8.7-6.2-8.7 6.2 3.3-10.2-8.7-6.3h10.8zm60.8 0 3.3 10.3h10.8l-8.7 6.3 3.3 10.1-8.7-6.2-8.7 6.2 3.4-10.2-8.8-6.3h10.7zm60.8 0 3.3 10.3h10.7l-8.6 6.3 3.3 10.1-8.7-6.2-8.7 6.2 3.3-10.2-8.6-6.3h10.7zm60.8 0 3.3 10.3h10.8l-8.8 6.3 3.4 10.1-8.7-6.2-8.7 6.2 3.4-10.2-8.8-6.3h10.8zM60.8 192l3.3 10.2H75l-8.7 6.3 3.3 10.3-8.7-6.4-8.7 6.3 3.3-10.2-8.6-6.3h10.7zm60.8 0 3.4 10.2h10.7l-8.8 6.3 3.4 10.3-8.7-6.4-8.7 6.3 3.3-10.2-8.7-6.3h10.8zm60.8 0 3.3 10.2h10.8l-8.7 6.3 3.3 10.3-8.7-6.4-8.7 6.3 3.3-10.2-8.6-6.3H179zm60.8 0 3.4 10.2h10.7l-8.7 6.3 3.3 10.3-8.7-6.4-8.6 6.3 3.2-10.2-8.7-6.3H240zm60.8 0 3.3 10.2h10.8l-8.7 6.3 3.3 10.3-8.7-6.4-8.7 6.3 3.3-10.2-8.6-6.3h10.7zM30.4 217.9l3.4 10.2h10.6l-8.6 6.3 3.3 10.2-8.7-6.3-8.6 6.3 3.2-10.3-8.7-6.3h10.9zm60.8 0 3.3 10.2h10.8l-8.7 6.3 3.3 10.2-8.7-6.3-8.7 6.3 3.4-10.3-8.7-6.3h10.6zm60.8 0 3.3 10.2H166l-8.4 6.3 3.3 10.2-8.7-6.3-8.7 6.3 3.3-10.3-8.7-6.3h10.8zm60.8 0 3.3 10.2h10.8l-8.7 6.3 3.3 10.2-8.7-6.3-8.7 6.3 3.4-10.3-8.8-6.3h10.7zm60.8 0 3.3 10.2h10.7l-8.6 6.3 3.3 10.2-8.7-6.3-8.7 6.3 3.3-10.3-8.6-6.3h10.7zm60.8 0 3.3 10.2h10.8l-8.8 6.3 3.4 10.2-8.7-6.3-8.7 6.3 3.4-10.3-8.8-6.3h10.8z'/%3e %3c/g%3e%3c/svg%3e";

const countries = [
    {
        title: 'IR',
        dialCode: '98',
        mask: '(...) ... ....',
        flag: img$1,
    },
    {
        title: 'AE',
        dialCode: '971',
        mask: '. ... ....',
        flag: img$2,
    },
    {
        title: 'US',
        dialCode: '1',
        mask: '... ... ....',
        flag: img,
    },
];

const StylesImage = styles.styled('img')({
    borderRadius: 4,
    height: 22,
    width: 28
});
class MobileInput extends React.Component {
    constructor() {
        super(...arguments);
        this.state = {
            value: this.props.defaultValue || null,
            value_when_focus: this.props.defaultValue || null,
            error: false,
            country: countries[0],
        };
        this.onChange = (event) => {
            this.normalizeValue(event.target.value, true);
        };
        this.onClick = (event) => {
            var _a, _b;
            clearTimeout(this.validationTimeout);
            this.setState(Object.assign(Object.assign({}, this.state), { error: false }));
            this.normalizeValue(this.state.value);
            (_b = (_a = this.props).onClick) === null || _b === void 0 ? void 0 : _b.call(_a, event);
        };
        this.onBlur = (e) => {
            var _a, _b, _c, _d;
            const value = e.target.value || null;
            if (value !== this.state.value_when_focus) {
                (_b = (_a = this.props)._call_parent_for_update) === null || _b === void 0 ? void 0 : _b.call(_a);
            }
            (_d = (_c = this.props).onBlur) === null || _d === void 0 ? void 0 : _d.call(_c, e);
        };
        this.onFocus = (e) => {
            var _a, _b;
            const value_when_focus = e.target.value || null;
            if (this.state.value_when_focus !== value_when_focus)
                this.setState(Object.assign(Object.assign({}, this.state), { value_when_focus }));
            (_b = (_a = this.props).onFocus) === null || _b === void 0 ? void 0 : _b.call(_a, e);
        };
        this.normalizeValue = (value, withoutEffect) => __awaiter(this, void 0, void 0, function* () {
            if (!value) {
                this.setValue(null, true, withoutEffect);
                return;
            }
            value = value.replace(/^0/, '');
            const pattern = this.state.country.mask;
            const pureValue = value.replace(/[^0-9]/g, '');
            const maskedValues = mask(pureValue, pattern, '_');
            yield this.setValue(pureValue ? maskedValues : null, true, withoutEffect);
            const valueForLength = maskedValues.match(/.*[0-9]/);
            if (this.inputRef && valueForLength) {
                this.inputRef.selectionStart = this.inputRef.selectionEnd = valueForLength[0].length;
            }
        });
        this.onChangeCountry = (event) => __awaiter(this, void 0, void 0, function* () {
            const dialCode = event.target.value;
            const country = countries.find(c => c.dialCode === dialCode);
            if (country) {
                yield this.setState(Object.assign(Object.assign({}, this.state), { country }));
            }
            if (this.state.value && country) {
                this.normalizeValue(this.state.value);
            }
        });
        this.click = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.click();
        };
        this.focus = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.focus();
        };
        this.blur = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.blur();
        };
    }
    shouldComponentUpdate(nextProps, nextState) {
        switch (true) {
            case this.state.value !== nextState.value:
            case this.state.error !== nextState.error:
            case this.state.country.dialCode !== nextState.country.dialCode:
            case this.props.label !== nextProps.label:
            case this.props.disabled !== nextProps.disabled:
                // case this.props.variant !== this.props.variant:
                return true;
            default: return false;
        }
    }
    setValue(value, internalSet = false, withoutEffect) {
        if (value === this.state.value)
            return Promise.resolve(value);
        if (value && !internalSet) {
            const splits = value.split('-');
            if (splits.length > 1) {
                const dialCode = splits[0].replace(/[^0-9]/g, '');
                const country = countries.find(c => c.dialCode === dialCode);
                if (country) {
                    this.setState(Object.assign(Object.assign({}, this.state), { country }));
                }
                this.normalizeValue(splits[1]);
                return Promise.resolve(splits[1]);
            }
            else {
                this.normalizeValue(value);
                return Promise.resolve(value);
            }
        }
        return new Promise((resolve) => {
            this.setState(Object.assign(Object.assign({}, this.state), { value }), () => {
                var _a, _b, _c, _d;
                if (!withoutEffect)
                    (_b = (_a = this.props)._call_parent_for_update) === null || _b === void 0 ? void 0 : _b.call(_a);
                (_d = (_c = this.props).onChangeValue) === null || _d === void 0 ? void 0 : _d.call(_c, value);
                resolve(value);
            });
        });
    }
    getValue() {
        if (!this.state.value)
            return null;
        const value = this.state.value.replace(/[^0-9]/g, '');
        return '+' + this.state.country.dialCode + '-' + value;
    }
    clear() {
        return this.setValue(this.props.defaultValue || null, true);
    }
    validation() {
        var _a;
        const matchValue = (_a = this.state.value) === null || _a === void 0 ? void 0 : _a.match(/.*[0-9]/);
        const isValid = matchValue && (matchValue[0].length === this.state.country.mask.length);
        if (!isValid && this.props.required) {
            clearTimeout(this.validationTimeout);
            this.setState(Object.assign(Object.assign({}, this.state), { error: true }));
            this.validationTimeout = setTimeout(() => {
                this.setState(Object.assign(Object.assign({}, this.state), { error: false }));
            }, 3000);
            return false;
        }
        return true;
    }
    render() {
        const _a = this.props, restProps = __rest(_a, ["defaultValue", "onChangeValue", "visible", "_call_parent_for_update"]);
        const isOutlined = this.props.variant === "outlined";
        let inputWidth = 207;
        switch (this.props.variant) {
            case "outlined":
                inputWidth = 235;
                break;
            case "filled":
                inputWidth = 231;
                break;
        }
        return (React__default["default"].createElement(material.Box, { sx: {
                display: 'inline-flex',
                alignItems: 'flex-end',
                width: this.props.fullWidth ? '100%' : inputWidth,
                position: 'relative'
            } },
            React__default["default"].createElement(material.Select, { value: this.state.country.dialCode, onChange: this.onChangeCountry, variant: "standard", margin: 'none', sx: {
                    width: '65px',
                    position: 'absolute',
                    zIndex: 2,
                    left: (isOutlined ? '8px' : 0),
                    top: (isOutlined ? '5px' : '18px'),
                    bottom: 2
                }, renderValue: (value) => {
                    return React__default["default"].createElement(material.Typography, { paddingLeft: '8px' },
                        "+",
                        value);
                }, disableUnderline: true }, countries.map((country, index) => {
                return (React__default["default"].createElement(material.MenuItem, { key: index, value: country.dialCode, sx: {
                        display: 'flex',
                        alignItems: 'center',
                        justifyContent: 'space-between',
                        minWidth: '100px',
                        paddingRight: '8px',
                        paddingLeft: '8px'
                    } },
                    React__default["default"].createElement(material.Typography, { display: 'inline' },
                        "+",
                        country.dialCode),
                    React__default["default"].createElement(StylesImage, { src: country.flag })));
            })),
            React__default["default"].createElement(TextField__default["default"], Object.assign({}, restProps, { variant: this.props.variant || "standard", error: this.state.error, onChange: this.onChange, onClick: this.onClick, onBlur: this.onBlur, onFocus: this.onFocus, value: this.state.value || '', inputRef: el => this.inputRef = el, slotProps: {
                    input: {
                        sx: { width: this.props.fullWidth ? '100%' : inputWidth },
                        startAdornment: (React__default["default"].createElement(material.InputAdornment, { position: 'start' },
                            React__default["default"].createElement(material.Box, { ml: '56px' })))
                    }
                } }))));
    }
}

class NumberInput extends React.Component {
    constructor() {
        super(...arguments);
        this.state = {
            value: this.props.defaultValue !== undefined ? this.props.defaultValue : null,
            value_when_focus: this.props.defaultValue !== undefined ? this.props.defaultValue : null,
            error: false
        };
        this.onChange = (event) => {
            let value = isNaN(parseInt(event.target.value, 10)) ? null : parseInt(event.target.value, 10);
            if (this.props.formatter && typeof this.props.formatter === "function") {
                const formattedValue = this.props.formatter(value);
                if (formattedValue !== undefined) {
                    value = formattedValue;
                }
            }
            this.setValue(value, true).then(() => {
                var _a, _b;
                (_b = (_a = this.props).onChange) === null || _b === void 0 ? void 0 : _b.call(_a, event);
            });
        };
        this.onClick = (event) => {
            var _a, _b;
            clearTimeout(this.validationTimeout);
            this.setState(Object.assign(Object.assign({}, this.state), { error: false }));
            (_b = (_a = this.props).onClick) === null || _b === void 0 ? void 0 : _b.call(_a, event);
        };
        this.onBlur = (e) => {
            var _a, _b, _c, _d;
            const value = Number(e.target.value) || null;
            if (value !== this.state.value_when_focus) {
                (_b = (_a = this.props)._call_parent_for_update) === null || _b === void 0 ? void 0 : _b.call(_a);
            }
            (_d = (_c = this.props).onBlur) === null || _d === void 0 ? void 0 : _d.call(_c, e);
        };
        this.onFocus = (e) => {
            var _a, _b;
            const value_when_focus = Number(e.target.value) || null;
            if (this.state.value_when_focus !== value_when_focus)
                this.setState(Object.assign(Object.assign({}, this.state), { value_when_focus }));
            (_b = (_a = this.props).onFocus) === null || _b === void 0 ? void 0 : _b.call(_a, e);
        };
        this.click = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.click();
        };
        this.focus = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.focus();
        };
        this.blur = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.blur();
        };
    }
    shouldComponentUpdate(nextProps, nextState) {
        switch (true) {
            case this.state.value !== nextState.value:
            case this.state.error !== nextState.error:
            case this.props.label !== nextProps.label:
            case this.props.disabled !== nextProps.disabled:
                return true;
            default: return false;
        }
    }
    setValue(value, withoutEffect) {
        if (value === this.state.value)
            return Promise.resolve(value);
        return new Promise((resolve) => {
            this.setState(Object.assign(Object.assign({}, this.state), { value }), () => {
                var _a, _b, _c, _d;
                if (!withoutEffect)
                    (_b = (_a = this.props)._call_parent_for_update) === null || _b === void 0 ? void 0 : _b.call(_a);
                (_d = (_c = this.props).onChangeValue) === null || _d === void 0 ? void 0 : _d.call(_c, value);
                resolve(value);
            });
        });
    }
    getValue() {
        return checkValue(this.state.value) ? this.state.value : null;
    }
    clear() {
        var _a;
        return this.setValue((_a = this.props.defaultValue) !== null && _a !== void 0 ? _a : null);
    }
    validation() {
        if (!checkValue(this.state.value) && this.props.required) {
            clearTimeout(this.validationTimeout);
            this.setState(Object.assign(Object.assign({}, this.state), { error: true }));
            this.validationTimeout = setTimeout(() => {
                this.setState(Object.assign(Object.assign({}, this.state), { error: false }));
            }, 3000);
            return false;
        }
        return true;
    }
    render() {
        const _a = this.props, restProps = __rest(_a, ["onChangeValue", "defaultValue", "visible", "_call_parent_for_update"]);
        return React__default["default"].createElement(TextField__default["default"], Object.assign({}, restProps, { variant: this.props.variant || "standard", error: this.state.error, onChange: this.onChange, onClick: this.onClick, onBlur: this.onBlur, onFocus: this.onFocus, value: checkValue(this.state.value) ? this.state.value : "", inputRef: el => this.inputRef = el }));
    }
}

class OtpInput extends React.Component {
    constructor() {
        super(...arguments);
        this.state = {
            value: this.props.defaultValue || null,
            value_when_focus: this.props.defaultValue || null,
            error: false,
            isInputFocused: false
        };
        this.onChange = (event) => {
            let value = event.target.value.replace(/[^0-9]/g, '');
            if (this.props.formatter && typeof this.props.formatter === "function") {
                const formattedValue = this.props.formatter(value);
                if (formattedValue !== undefined) {
                    value = formattedValue;
                }
            }
            this.setValue(value || null, true).then(() => {
                var _a, _b;
                (_b = (_a = this.props).onChange) === null || _b === void 0 ? void 0 : _b.call(_a, event);
            });
        };
        this.onClick = (event) => {
            clearTimeout(this.validationTimeout);
            this.setState(Object.assign(Object.assign({}, this.state), { error: false, isInputFocused: true }), () => {
                var _a, _b, _c;
                (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.focus();
                (_c = (_b = this.props).onClick) === null || _c === void 0 ? void 0 : _c.call(_b, event);
            });
        };
        this.onBlur = (e) => {
            var _a, _b, _c, _d;
            this.setState(Object.assign(Object.assign({}, this.state), { isInputFocused: false }));
            const value = e.target.value || null;
            if (value !== this.state.value_when_focus) {
                (_b = (_a = this.props)._call_parent_for_update) === null || _b === void 0 ? void 0 : _b.call(_a);
            }
            (_d = (_c = this.props).onBlur) === null || _d === void 0 ? void 0 : _d.call(_c, e);
        };
        this.onFocus = (e) => {
            this.setState(Object.assign(Object.assign({}, this.state), { isInputFocused: true }), () => {
                var _a, _b;
                const value_when_focus = e.target.value || null;
                if (this.state.value_when_focus !== value_when_focus)
                    this.setState(Object.assign(Object.assign({}, this.state), { value_when_focus }));
                (_b = (_a = this.props).onFocus) === null || _b === void 0 ? void 0 : _b.call(_a, e);
            });
        };
        this.click = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.click();
        };
        this.focus = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.focus();
        };
        this.blur = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.blur();
        };
    }
    shouldComponentUpdate(_, nextState) {
        switch (true) {
            case this.state.value !== nextState.value:
            case this.state.error !== nextState.error:
            case this.state.isInputFocused !== nextState.isInputFocused:
                return true;
            default: return false;
        }
    }
    setValue(value, withoutEffect) {
        return __awaiter(this, void 0, void 0, function* () {
            if (value === this.state.value)
                return Promise.resolve(value);
            return new Promise((resolve) => {
                this.setState(Object.assign(Object.assign({}, this.state), { value }), () => {
                    var _a, _b, _c, _d;
                    if (!withoutEffect)
                        (_b = (_a = this.props)._call_parent_for_update) === null || _b === void 0 ? void 0 : _b.call(_a);
                    (_d = (_c = this.props).onChangeValue) === null || _d === void 0 ? void 0 : _d.call(_c, value);
                    resolve(value);
                });
            });
        });
    }
    getValue() {
        return this.state.value || null;
    }
    clear() {
        return this.setValue(this.props.defaultValue || null);
    }
    validation() {
        if (!this.state.value || this.state.value.length < (this.props.digits || 4) && this.props.required) {
            clearTimeout(this.validationTimeout);
            this.setState(Object.assign(Object.assign({}, this.state), { error: true }));
            this.validationTimeout = setTimeout(() => {
                this.setState(Object.assign(Object.assign({}, this.state), { error: false }));
            }, 3000);
            return false;
        }
        return true;
    }
    render() {
        var _a;
        const settings = {
            digits: this.props.digits || 4,
            borderWidth: this.props.borderWidth || 1,
            height: this.props.height || 55,
            width: this.props.width || 34.61,
            spaceBetween: this.props.spaceBetween || 8,
            borderRadius: this.props.borderRadius || 4,
            emptyColor: this.props.emptyColor || "#0000003b",
            focusColor: this.props.focusColor || "#1976d2",
            completeColor: this.props.completeColor || "#68b36b",
            fontWeight: this.props.fontWeight || 400,
            fontSize: this.props.fontSize || 23,
            color: this.props.color || '#323232'
        };
        const boxes = Array.from(Array(settings.digits).keys());
        const values = ((_a = this.state.value) === null || _a === void 0 ? void 0 : _a.split('')) || [];
        return (React__default["default"].createElement(React.Fragment, null,
            React__default["default"].createElement(material.Box, { sx: {
                    width: (settings.width * settings.digits) + ((settings.borderWidth * 2) * settings.digits) + (settings.spaceBetween * (settings.digits - 1)),
                    display: 'inline-block',
                    verticalAlign: "top",
                    position: 'relative',
                } },
                React__default["default"].createElement(material.Box, { onClick: this.onClick, sx: {
                        display: 'flex',
                        alignItems: 'center',
                        justifyContent: 'space-between',
                    } },
                    React__default["default"].createElement("input", { autoFocus: this.props.autoFocus, style: { position: 'absolute', zIndex: -1, opacity: 0 }, onChange: this.onChange, onBlur: this.onBlur, onFocus: this.onFocus, value: this.state.value || "", maxLength: settings.digits, inputMode: 'numeric', ref: el => this.inputRef = el }),
                    boxes.map((key) => {
                        const value = values[key] || "";
                        return (React__default["default"].createElement(material.Box, { key: key, sx: {
                                height: settings.height,
                                width: settings.width,
                                transition: '0.2s border-color',
                                borderRadius: this.props.variant !== "outlined" ? 0 : settings.borderRadius + 'px',
                                borderStyle: 'solid',
                                borderWidth: settings.borderWidth + 'px',
                                borderRightWidth: this.props.variant !== "outlined" ? 0 : settings.borderWidth,
                                borderLeftWidth: this.props.variant !== "outlined" ? 0 : settings.borderWidth,
                                borderTopWidth: this.props.variant !== "outlined" ? 0 : settings.borderWidth,
                                borderColor: this.state.error && !value ? '#d32f2f' :
                                    this.state.isInputFocused && values.length === key
                                        ? settings.focusColor
                                        : (values.length === settings.digits
                                            ? (this.state.isInputFocused && (settings.digits === key + 1)
                                                ? settings.focusColor
                                                : settings.completeColor)
                                            : settings.emptyColor),
                            } },
                            React__default["default"].createElement(material.Slide, { in: value ? true : false, direction: "down", appear: false },
                                React__default["default"].createElement(material.Typography, { sx: {
                                        height: '100%',
                                        width: '100%',
                                        display: 'flex',
                                        alignItems: 'center',
                                        justifyContent: 'center',
                                        fontWeight: settings.fontWeight,
                                        fontSize: settings.fontSize,
                                        color: settings.color
                                    } }, value || "☓"))));
                    })))));
    }
}

class PasswordInput extends React.Component {
    constructor() {
        super(...arguments);
        this.state = {
            value: this.props.defaultValue || null,
            value_when_focus: this.props.defaultValue || null,
            error: false,
            showPassword: false
        };
        this.onChange = (event) => {
            let value = event.target.value;
            if (this.props.formatter && typeof this.props.formatter === "function") {
                const formattedValue = this.props.formatter(value);
                if (formattedValue !== undefined) {
                    value = formattedValue;
                }
            }
            this.setValue(value || null, true).then(() => {
                var _a, _b;
                (_b = (_a = this.props).onChange) === null || _b === void 0 ? void 0 : _b.call(_a, event);
            });
        };
        this.onClick = (event) => {
            var _a, _b;
            clearTimeout(this.validationTimeout);
            if (this.state.error)
                this.setState(Object.assign(Object.assign({}, this.state), { error: false }));
            (_b = (_a = this.props).onClick) === null || _b === void 0 ? void 0 : _b.call(_a, event);
        };
        this.onBlur = (e) => {
            var _a, _b, _c, _d;
            const value = e.target.value || null;
            if (value !== this.state.value_when_focus) {
                (_b = (_a = this.props)._call_parent_for_update) === null || _b === void 0 ? void 0 : _b.call(_a);
            }
            (_d = (_c = this.props).onBlur) === null || _d === void 0 ? void 0 : _d.call(_c, e);
        };
        this.onFocus = (e) => {
            var _a, _b;
            const value_when_focus = e.target.value || null;
            if (this.state.value_when_focus !== value_when_focus)
                this.setState(Object.assign(Object.assign({}, this.state), { value_when_focus }));
            (_b = (_a = this.props).onFocus) === null || _b === void 0 ? void 0 : _b.call(_a, e);
        };
        this.handleClickShowPassword = () => {
            this.setState(Object.assign(Object.assign({}, this.state), { showPassword: !this.state.showPassword }));
        };
        this.click = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.click();
        };
        this.focus = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.focus();
        };
        this.blur = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.blur();
        };
    }
    shouldComponentUpdate(nextProps, nextState) {
        switch (true) {
            case this.state.value !== nextState.value:
            case this.state.error !== nextState.error:
            case this.state.showPassword !== nextState.showPassword:
            case this.props.label !== nextProps.label:
            case this.props.disabled !== nextProps.disabled:
                return true;
            default: return false;
        }
    }
    setValue(value, withoutEffect) {
        if (value === this.state.value)
            return Promise.resolve(value);
        return new Promise((resolve) => {
            this.setState(Object.assign(Object.assign({}, this.state), { value }), () => {
                var _a, _b, _c, _d;
                if (!withoutEffect)
                    (_b = (_a = this.props)._call_parent_for_update) === null || _b === void 0 ? void 0 : _b.call(_a);
                (_d = (_c = this.props).onChangeValue) === null || _d === void 0 ? void 0 : _d.call(_c, value);
                resolve(value);
            });
        });
    }
    getValue() {
        return this.state.value || null;
    }
    clear() {
        return this.setValue(this.props.defaultValue || null);
    }
    validation() {
        if (!this.state.value && this.props.required) {
            clearTimeout(this.validationTimeout);
            this.setState(Object.assign(Object.assign({}, this.state), { error: true }));
            this.validationTimeout = setTimeout(() => {
                this.setState(Object.assign(Object.assign({}, this.state), { error: false }));
            }, 3000);
            return false;
        }
        return true;
    }
    render() {
        const _a = this.props, restProps = __rest(_a, ["defaultValue", "onChangeValue", "visible", "_call_parent_for_update"]);
        let variantWidth = '207px';
        if (this.props.variant === "outlined")
            variantWidth = "235px";
        if (this.props.variant === "filled")
            variantWidth = "231px";
        const inputWidth = this.props.fullWidth ? '100%' : variantWidth;
        return (React__default["default"].createElement(TextField__default["default"], Object.assign({}, restProps, { sx: Object.assign(Object.assign({}, this.props.sx), { width: inputWidth }), type: this.state.showPassword ? 'text' : 'password', variant: this.props.variant || "standard", error: this.state.error, onChange: this.onChange, onClick: this.onClick, onBlur: this.onBlur, onFocus: this.onFocus, value: this.state.value || '', inputRef: el => this.inputRef = el, slotProps: {
                input: {
                    endAdornment: (React__default["default"].createElement(material.InputAdornment, { position: "end" },
                        React__default["default"].createElement(material.IconButton, { onClick: this.handleClickShowPassword }, this.state.showPassword ? React__default["default"].createElement(VisibilityIcon__default["default"], null) : React__default["default"].createElement(VisibilityOffIcon__default["default"], null))))
                }
            } })));
    }
}

const LoadingComponent = () => (React__default["default"].createElement(material.Grow, { in: true, timeout: 550 },
    React__default["default"].createElement(material.Box, { sx: { paddingRight: '16px', paddingTop: '4px' } },
        React__default["default"].createElement(material.CircularProgress, { size: 18 }))));
class SelectInput extends React.Component {
    constructor() {
        super(...arguments);
        this.state = {
            value: this.props.defaultValue || null,
            error: false
        };
        this.onChange = (event, child) => {
            var _a, _b;
            const value = event.target.value;
            this.setValue(value || null);
            (_b = (_a = this.props).onChange) === null || _b === void 0 ? void 0 : _b.call(_a, event, child);
        };
        this.onOpen = (event) => {
            var _a, _b;
            clearTimeout(this.validationTimeout);
            this.setState(Object.assign(Object.assign({}, this.state), { error: false }));
            (_b = (_a = this.props).onOpen) === null || _b === void 0 ? void 0 : _b.call(_a, event);
        };
        this.click = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.click();
        };
        this.focus = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.focus();
        };
        this.blur = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.blur();
        };
    }
    shouldComponentUpdate(nextProps, nextState) {
        switch (true) {
            case this.state.value !== nextState.value:
            case this.state.error !== nextState.error:
            case this.props.options.map(i => i.value).join('@') !== nextProps.options.map(i => i.value).join('@'):
            case this.props.loading !== nextProps.loading:
            case this.props.label !== nextProps.label:
            case this.props.disabled !== nextProps.disabled:
                return true;
            default: return false;
        }
    }
    componentDidUpdate(props) {
        if (this.props.options.map(i => i.value).join('@') !== props.options.map(i => i.value).join('@')) {
            this.setValue(null);
        }
    }
    setValue(value) {
        if (value === this.state.value)
            return Promise.resolve(value);
        const valueToSet = value;
        return new Promise((resolve) => {
            this.setState(Object.assign(Object.assign({}, this.state), { value: valueToSet }), () => {
                var _a, _b, _c, _d;
                (_b = (_a = this.props)._call_parent_for_update) === null || _b === void 0 ? void 0 : _b.call(_a);
                (_d = (_c = this.props).onChangeValue) === null || _d === void 0 ? void 0 : _d.call(_c, valueToSet);
                resolve(valueToSet);
            });
        });
    }
    getValue() {
        return this.state.value || null;
    }
    clear() {
        return this.setValue(this.props.defaultValue || null);
    }
    validation() {
        if (!this.state.value && this.props.required) {
            clearTimeout(this.validationTimeout);
            this.setState(Object.assign(Object.assign({}, this.state), { error: true }));
            this.validationTimeout = setTimeout(() => {
                this.setState(Object.assign(Object.assign({}, this.state), { error: false }));
            }, 3000);
            return false;
        }
        return true;
    }
    render() {
        const _a = this.props, { onChangeValue, variant, visible, required, _call_parent_for_update, loading, listSubheaderText, defaultValue } = _a, restProps = __rest(_a, ["onChangeValue", "variant", "visible", "required", "_call_parent_for_update", "loading", "listSubheaderText", "defaultValue"]);
        let variantWidth = '207px';
        if (this.props.variant === "outlined")
            variantWidth = "235px";
        if (this.props.variant === "filled")
            variantWidth = "231px";
        const inputWidth = this.props.fullWidth ? '100%' : variantWidth;
        return (React__default["default"].createElement(material.FormControl, { sx: { width: inputWidth }, variant: variant || "standard", error: this.state.error, id: this.props.selector },
            React__default["default"].createElement(material.InputLabel, { required: required, id: `${this.props.selector + "-select-label"}`, htmlFor: `${this.props.selector + "-select-input"}` }, this.props.label),
            React__default["default"].createElement(material.Select, Object.assign({}, restProps, { labelId: `${this.props.selector + "-select-label"}`, inputProps: {
                    id: `${this.props.selector + "-select-input"}`
                }, id: `${this.props.selector + "-select-identity"}`, onOpen: this.onOpen, value: this.state.value || (this.props.multiple ? [] : ""), onChange: this.onChange, disabled: this.props.disabled || this.props.loading, IconComponent: this.props.loading ? LoadingComponent : (this.props.IconComponent || ArrowDropDownIcon__default["default"]), inputRef: el => this.inputRef = el }), !this.props.options.length ? (React__default["default"].createElement(material.ListSubheader, { sx: { textAlign: 'center' } }, this.props.listSubheaderText || ("Items Not Found"))) : this.props.options.map((option, key) => React__default["default"].createElement(material.MenuItem, { key: key, value: option.value }, option.label)))));
    }
}

class TextInput extends React.Component {
    constructor() {
        super(...arguments);
        this.state = {
            value: this.props.defaultValue || null,
            value_when_focus: this.props.defaultValue || null,
            error: false
        };
        this.onChange = (event) => {
            let value = event.target.value;
            if (this.props.formatter && typeof this.props.formatter === "function") {
                const formattedValue = this.props.formatter(value);
                if (formattedValue !== undefined) {
                    value = formattedValue;
                }
            }
            this.setValue(value || null, true).then(() => {
                var _a, _b;
                (_b = (_a = this.props).onChange) === null || _b === void 0 ? void 0 : _b.call(_a, event);
            });
        };
        this.onClick = (event) => {
            var _a, _b;
            clearTimeout(this.validationTimeout);
            this.setState(Object.assign(Object.assign({}, this.state), { error: false }));
            (_b = (_a = this.props).onClick) === null || _b === void 0 ? void 0 : _b.call(_a, event);
        };
        this.onBlur = (e) => {
            var _a, _b, _c, _d;
            const value = e.target.value || null;
            if (value !== this.state.value_when_focus) {
                (_b = (_a = this.props)._call_parent_for_update) === null || _b === void 0 ? void 0 : _b.call(_a);
            }
            (_d = (_c = this.props).onBlur) === null || _d === void 0 ? void 0 : _d.call(_c, e);
        };
        this.onFocus = (e) => {
            var _a, _b;
            const value_when_focus = e.target.value || null;
            if (this.state.value_when_focus !== value_when_focus)
                this.setState(Object.assign(Object.assign({}, this.state), { value_when_focus }));
            (_b = (_a = this.props).onFocus) === null || _b === void 0 ? void 0 : _b.call(_a, e);
        };
        this.click = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.click();
        };
        this.focus = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.focus();
        };
        this.blur = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.blur();
        };
    }
    shouldComponentUpdate(nextProps, nextState) {
        switch (true) {
            case this.state.value !== nextState.value:
            case this.state.error !== nextState.error:
            case this.props.label !== nextProps.label:
            case this.props.disabled !== nextProps.disabled:
                return true;
            default: return false;
        }
    }
    setValue(value, withoutEffect) {
        if (value === this.state.value)
            return Promise.resolve(value);
        return new Promise((resolve) => {
            this.setState(Object.assign(Object.assign({}, this.state), { value }), () => {
                var _a, _b, _c, _d;
                if (!withoutEffect)
                    (_b = (_a = this.props)._call_parent_for_update) === null || _b === void 0 ? void 0 : _b.call(_a);
                (_d = (_c = this.props).onChangeValue) === null || _d === void 0 ? void 0 : _d.call(_c, value);
                resolve(value);
            });
        });
    }
    getValue() {
        return this.state.value || null;
    }
    clear() {
        return this.setValue(this.props.defaultValue || null);
    }
    validation() {
        if (!this.state.value && this.props.required) {
            clearTimeout(this.validationTimeout);
            this.setState(Object.assign(Object.assign({}, this.state), { error: true }));
            this.validationTimeout = setTimeout(() => {
                this.setState(Object.assign(Object.assign({}, this.state), { error: false }));
            }, 3000);
            return false;
        }
        return true;
    }
    render() {
        const _a = this.props, restProps = __rest(_a, ["defaultValue", "onChangeValue", "visible", "formatter", "_call_parent_for_update"]);
        return React__default["default"].createElement(TextField__default["default"], Object.assign({}, restProps, { variant: this.props.variant || "standard", error: this.state.error, onChange: this.onChange, onClick: this.onClick, onBlur: this.onBlur, onFocus: this.onFocus, value: this.state.value || '', inputRef: el => this.inputRef = el }));
    }
}

class TimeInput extends React.Component {
    constructor() {
        super(...arguments);
        this.state = {
            value: this.props.defaultValue || null,
            error: false
        };
        this.onChange = (value, context) => {
            // let value = inputValue && inputValue.toDate ? inputValue.toDate() : inputValue;
            this.setValue(value || null).then(() => {
                var _a, _b;
                (_b = (_a = this.props).onChange) === null || _b === void 0 ? void 0 : _b.call(_a, value, context);
            });
        };
        this.onClick = (event) => {
            var _a, _b;
            clearTimeout(this.validationTimeout);
            this.setState(Object.assign(Object.assign({}, this.state), { error: false }));
            (_b = (_a = this.props.InputProps) === null || _a === void 0 ? void 0 : _a.onClick) === null || _b === void 0 ? void 0 : _b.call(_a, event);
        };
        this.click = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.click();
        };
        this.focus = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.focus();
        };
        this.blur = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.blur();
        };
    }
    shouldComponentUpdate(nextProps, nextState) {
        switch (true) {
            case this.state.value !== nextState.value:
            case this.state.error !== nextState.error:
            case this.props.label !== nextProps.label:
            case this.props.label !== nextProps.label:
                return true;
            default: return false;
        }
    }
    setValue(value) {
        if (value === this.state.value)
            return Promise.resolve(value);
        return new Promise((resolve) => {
            this.setState(Object.assign(Object.assign({}, this.state), { value }), () => {
                var _a, _b, _c, _d;
                (_b = (_a = this.props)._call_parent_for_update) === null || _b === void 0 ? void 0 : _b.call(_a);
                (_d = (_c = this.props).onChangeValue) === null || _d === void 0 ? void 0 : _d.call(_c, value);
                resolve(value);
            });
        });
    }
    getValue() {
        return this.state.value || null;
    }
    clear() {
        return this.setValue(this.props.defaultValue || null);
    }
    validation() {
        if (!this.state.value && this.props.required) {
            clearTimeout(this.validationTimeout);
            this.setState(Object.assign(Object.assign({}, this.state), { error: true }));
            this.validationTimeout = setTimeout(() => {
                this.setState(Object.assign(Object.assign({}, this.state), { error: false }));
            }, 3000);
            return false;
        }
        return true;
    }
    render() {
        const _a = this.props, { defaultValue, onChangeValue, dateAdapter, variant, required, visible, _call_parent_for_update } = _a, restProps = __rest(_a, ["defaultValue", "onChangeValue", "dateAdapter", "variant", "required", "visible", "_call_parent_for_update"]);
        return (React__default["default"].createElement(xDatePickers.LocalizationProvider, { dateAdapter: dateAdapter || AdapterDayjs.AdapterDayjs },
            React__default["default"].createElement(xDatePickers.TimePicker, Object.assign({}, restProps, { ampm: this.props.ampm || false, value: this.state.value, onChange: this.onChange, inputRef: el => this.inputRef = el, slots: {
                    textField: (params) => (React__default["default"].createElement(TextField__default["default"], Object.assign({}, params, this.props.InputProps, { fullWidth: this.props.fullWidth || false, variant: variant || "standard", required: required || false, error: this.state.error, onClick: this.onClick })))
                } }))));
    }
}

class ToggleInput extends React.Component {
    constructor() {
        super(...arguments);
        this.state = {
            value: checkValue(this.props.defaultValue) ? (this.props.defaultValue === undefined ? null : this.props.defaultValue) : null,
            error: false
        };
        this.onChange = (_, value) => {
            this.setValue(checkValue(value) ? value : (this.props.enforceValueSet ? this.state.value : null)).then(() => {
                var _a, _b;
                (_b = (_a = this.props).onChange) === null || _b === void 0 ? void 0 : _b.call(_a, _, value);
            });
        };
        this.click = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.click();
        };
        this.focus = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.focus();
        };
        this.blur = () => {
            var _a;
            (_a = this.inputRef) === null || _a === void 0 ? void 0 : _a.blur();
        };
    }
    shouldComponentUpdate(nextProps, nextState) {
        switch (true) {
            case this.state.value !== nextState.value:
            case this.state.error !== nextState.error:
            case this.props.label !== nextProps.label:
            case this.props.options.map(i => i.value).join('@') !== nextProps.options.map(i => i.value).join('@'):
            case this.props.label !== nextProps.label:
                return true;
            default: return false;
        }
    }
    setValue(value) {
        if (value === this.state.value)
            return Promise.resolve(value);
        return new Promise((resolve) => {
            this.setState(Object.assign(Object.assign({}, this.state), { value }), () => {
                var _a, _b, _c, _d;
                (_b = (_a = this.props)._call_parent_for_update) === null || _b === void 0 ? void 0 : _b.call(_a);
                (_d = (_c = this.props).onChangeValue) === null || _d === void 0 ? void 0 : _d.call(_c, value);
                resolve(value);
            });
        });
    }
    getValue() {
        return checkValue(this.state.value) ? this.state.value : null;
    }
    clear() {
        return this.setValue(this.props.defaultValue || null);
    }
    validation() {
        if (!checkValue(this.state.value) && this.props.required) {
            clearTimeout(this.validationTimeout);
            this.setState(Object.assign(Object.assign({}, this.state), { error: true }));
            this.validationTimeout = setTimeout(() => {
                this.setState(Object.assign(Object.assign({}, this.state), { error: false }));
            }, 3000);
            return false;
        }
        return true;
    }
    render() {
        const _a = this.props, restProps = __rest(_a, ["onChangeValue", "visible", "formatter", "defaultValue", "label", "_call_parent_for_update", "enforceValueSet"]);
        return (React__default["default"].createElement(material.ToggleButtonGroup, Object.assign({}, restProps, { color: this.state.error ? 'error' : (this.props.color || "primary"), value: this.state.value, exclusive: this.props.exclusive === false ? false : true, onChange: this.onChange }), this.props.options.map((option, key) => React__default["default"].createElement(material.ToggleButton, { key: `${key}-${option.value}`, value: option.value }, option.label))));
    }
}

class FormBuilder extends React.Component {
    constructor() {
        super(...arguments);
        this.state = {
            isMounted: false,
            time: null,
            inInternalSettingProcess: false
        };
        this.inputRefs = {};
        this.inputs = {
            text: TextInput,
            number: NumberInput,
            items: ItemsInput,
            custom: CustomInput,
            checkbox: CheckboxInput,
            mobile: MobileInput,
            otp: OtpInput,
            password: PasswordInput,
            select: SelectInput,
            date: DateInput,
            time: TimeInput,
            datetime: DatetimeInput,
            mask: MaskInput,
            file: FileInput,
            autocomplete: AutocompleteInput,
            toggle: ToggleInput,
            group: GroupInput
        };
        this.defaultValues = null;
        this.didMountEvent = [];
        this.getValues = (validation = true) => {
            const data = this.defaultValues || {};
            const invalidInputs = [];
            this.props.inputs.forEach(inputProps => {
                const input = this.inputRefs[inputProps.selector];
                if (input) {
                    if (validation) {
                        const isValid = input.validation();
                        if ((inputProps.required || inputProps.type === "items" || inputProps.type === "group" || inputProps.type === "custom") && !isValid) {
                            invalidInputs.push(inputProps);
                        }
                    }
                    let value = input.getValue(validation);
                    if (inputProps.getMutator && typeof inputProps.getMutator === "function") {
                        // @ts-ignore
                        let mutatedValue = inputProps.getMutator(value);
                        value = mutatedValue !== undefined ? mutatedValue : value;
                    }
                    setToObject(inputProps.selector, value, data);
                }
            });
            return {
                data,
                validation: {
                    status: invalidInputs.length < 1,
                    inputs: invalidInputs
                },
            };
        };
        this.setValues = (value) => __awaiter(this, void 0, void 0, function* () {
            if (!this.state.isMounted) {
                this.didMountEvent.push(() => this.syncSetValues(value));
            }
            else {
                return this.syncSetValues(value);
            }
        });
        this.syncSetValues = (value) => __awaiter(this, void 0, void 0, function* () {
            this.defaultValues = value;
            return new Promise((resolve) => {
                this.setState(Object.assign(Object.assign({}, this.state), { inInternalSettingProcess: true }), () => __awaiter(this, void 0, void 0, function* () {
                    for (const selector in value) {
                        const valueItem = value[selector];
                        yield this.setValue(selector, valueItem);
                    }
                    this.setState(Object.assign(Object.assign({}, this.state), { inInternalSettingProcess: false }), () => {
                        var _a, _b;
                        (_b = (_a = this.props).onChange) === null || _b === void 0 ? void 0 : _b.call(_a, this.getValues(false));
                        resolve(true);
                    });
                }));
            });
        });
        this.clear = () => __awaiter(this, void 0, void 0, function* () {
            return new Promise((resolve) => __awaiter(this, void 0, void 0, function* () {
                this.setState(Object.assign(Object.assign({}, this.state), { inInternalSettingProcess: true }), () => __awaiter(this, void 0, void 0, function* () {
                    for (const selector in this.inputRefs) {
                        const input = this.inputRefs[selector];
                        if (input) {
                            yield input.clear();
                        }
                    }
                    this.setState(Object.assign(Object.assign({}, this.state), { inInternalSettingProcess: false }), () => {
                        var _a, _b;
                        (_b = (_a = this.props).onChange) === null || _b === void 0 ? void 0 : _b.call(_a, this.getValues(false));
                        resolve(true);
                    });
                }));
            }));
        });
        this.lastVisibilityOfInputs = {};
        this.checkVisibility = (input) => {
            var _a, _b;
            let visible = true;
            if (typeof input.visible === "function") {
                visible = input.visible((_a = this.getValues(false)) === null || _a === void 0 ? void 0 : _a.data);
            }
            else {
                visible = input.visible;
            }
            const output = visible === true || visible === undefined ? true : false;
            const prev = (_b = this.lastVisibilityOfInputs[input.selector]) === null || _b === void 0 ? void 0 : _b.now;
            if (prev !== undefined) {
                this.lastVisibilityOfInputs = Object.assign(Object.assign({}, this.lastVisibilityOfInputs), { [input.selector]: { prev, now: output } });
            }
            else {
                this.lastVisibilityOfInputs = Object.assign(Object.assign({}, this.lastVisibilityOfInputs), { [input.selector]: { prev, now: output } });
            }
            return output;
        };
        this.onUpdateInputs = () => {
            return new Promise((resolve) => {
                if (!this.state.inInternalSettingProcess) {
                    this.setState(Object.assign(Object.assign({}, this.state), { time: new Date().getTime() }), () => {
                        var _a, _b;
                        (_b = (_a = this.props).onChange) === null || _b === void 0 ? void 0 : _b.call(_a, this.getValues(false));
                        resolve(true);
                    });
                }
                else {
                    resolve(true);
                }
            });
        };
        this.executeAction = (selector, action, value) => __awaiter(this, void 0, void 0, function* () {
            return new Promise((resolve) => __awaiter(this, void 0, void 0, function* () {
                let output;
                if (this.state.isMounted) {
                    if (value !== undefined) {
                        // @ts-ignore
                        output = yield this.inputRefs[`${selector}`][`${action}`](value);
                    }
                    else {
                        // @ts-ignore
                        output = yield this.inputRefs[`${selector}`][`${action}`]();
                    }
                    resolve(output);
                }
                else {
                    if (value !== undefined) {
                        this.didMountEvent.push(() => __awaiter(this, void 0, void 0, function* () {
                            // @ts-ignore
                            let output = yield this.inputRefs[`${selector}`][`${action}`](value);
                            resolve(output);
                        }));
                    }
                    else {
                        this.didMountEvent.push(() => __awaiter(this, void 0, void 0, function* () {
                            // @ts-ignore
                            let output = yield this.inputRefs[`${selector}`][`${action}`]();
                            resolve(output);
                        }));
                    }
                }
            }));
        });
        this.renderInput = (input, index) => {
            if (!this.checkVisibility(input))
                return null;
            const { wrapper, getMutator, setMutator, ref } = input, props = __rest(input, ["wrapper", "getMutator", "setMutator", "ref"]);
            const actions = {
                setValue: (value) => this.executeAction(input.selector, 'setValue', value),
                getValue: (validation) => this.executeAction(input.selector, 'getValue', validation),
                clear: () => this.executeAction(input.selector, 'clear'),
                click: () => this.executeAction(input.selector, 'click'),
                focus: () => this.executeAction(input.selector, 'focus'),
                blur: () => this.executeAction(input.selector, 'blur')
            };
            const refSetter = (el) => {
                this.inputRefs[input.selector] = el;
                if (typeof (ref) === "function")
                    ref(el);
            };
            const element = React__default["default"].createElement(this.inputs[input.type], Object.assign(Object.assign({ ref: (el) => refSetter(el) }, props), { _call_parent_for_update: this.onUpdateInputs }));
            const output = (React__default["default"].createElement(React.Fragment, { key: index }, wrapper ? wrapper(element, actions) : element));
            return output;
        };
    }
    componentDidMount() {
        this.setState(Object.assign(Object.assign({}, this.state), { isMounted: true }), () => __awaiter(this, void 0, void 0, function* () {
            var _a, _b;
            yield Promise.all(this.didMountEvent.map((func) => func()));
            (_b = (_a = this.props).onMount) === null || _b === void 0 ? void 0 : _b.call(_a, this.getValues(false));
        }));
    }
    componentWillUnmount() {
        this.setState(Object.assign(Object.assign({}, this.state), { isMounted: false }));
    }
    componentDidUpdate() {
        this.props.inputs.forEach((item) => {
            var _a, _b;
            const prevVisible = (_a = this.lastVisibilityOfInputs[item.selector]) === null || _a === void 0 ? void 0 : _a.prev;
            const nowVisible = (_b = this.lastVisibilityOfInputs[item.selector]) === null || _b === void 0 ? void 0 : _b.now;
            if ((prevVisible !== nowVisible) && this.defaultValues && Object.keys(this.defaultValues).length) {
                this.setValue(item.selector, this.defaultValues[item.selector]);
            }
        });
    }
    setObjectValues(object_1) {
        return __awaiter(this, arguments, void 0, function* (object, path = []) {
            const objectKeys = Object.keys(object);
            for (let i = 0; i < objectKeys.length; i++) {
                const key = objectKeys[i];
                const value = object[key];
                const joinedSelector = [...path, key].join('.');
                const directInput = this.props.inputs.find(i => i.selector === joinedSelector);
                if (directInput && (directInput.type === "group" || (directInput.type === "custom" && directInput.allowObject))) {
                    yield this.setNormalValue(joinedSelector, value);
                }
                else if (value !== null && typeof value === "object" && !Array.isArray(value)) {
                    yield this.setObjectValues(value, [...path, key]);
                }
                else {
                    const selector = [...path, key].join('.');
                    yield this.setNormalValue(selector, value);
                }
            }
        });
    }
    setNormalValue(selector, value) {
        return __awaiter(this, void 0, void 0, function* () {
            const regex = new RegExp('^(' + selector + ')\\[.*\\=.*\\]\\..*');
            const keyValueSelectors = Object.keys(this.inputRefs).filter(i => regex.test(i));
            if (Array.isArray(value) && keyValueSelectors.length) {
                return yield Promise.all(keyValueSelectors.map((keyValueSelector) => __awaiter(this, void 0, void 0, function* () {
                    let valueItem = selectFromObject(keyValueSelector.replace(selector, ''), value);
                    const input = this.inputRefs[keyValueSelector];
                    if (!input || valueItem === undefined)
                        return false;
                    const inputProps = this.props.inputs.find(i => i.selector === keyValueSelector);
                    if ((inputProps === null || inputProps === void 0 ? void 0 : inputProps.setMutator) && typeof inputProps.setMutator === "function") {
                        const mutatedValue = inputProps.setMutator(valueItem);
                        valueItem = mutatedValue !== undefined ? mutatedValue : valueItem;
                    }
                    return input.setValue(valueItem);
                })));
            }
            else {
                const input = this.inputRefs[selector];
                if (!input)
                    return null;
                const inputProps = this.props.inputs.find(i => i.selector === selector);
                if ((inputProps === null || inputProps === void 0 ? void 0 : inputProps.setMutator) && typeof inputProps.setMutator === "function") {
                    const mutatedValue = inputProps.setMutator(value);
                    value = mutatedValue !== undefined ? mutatedValue : value;
                }
                return yield (input === null || input === void 0 ? void 0 : input.setValue(value));
            }
        });
    }
    setValue(selector, value) {
        return __awaiter(this, void 0, void 0, function* () {
            const directInput = this.props.inputs.find(i => i.selector === selector);
            if (directInput && (directInput.type === "group" || (directInput.type === "custom" && directInput.allowObject))) {
                return yield this.setNormalValue(selector, value);
            }
            if (value !== null && typeof value === "object" && !Array.isArray(value) && !(value instanceof Date)) {
                return yield this.setObjectValues(value, [selector]);
            }
            else {
                return yield this.setNormalValue(selector, value);
            }
        });
    }
    render() {
        return (React__default["default"].createElement(React.Fragment, null, this.props.inputs.map(this.renderInput)));
    }
}

exports.AutocompleteInput = AutocompleteInput;
exports.CheckboxInput = CheckboxInput;
exports.CustomInput = CustomInput;
exports.DateInput = DateInput;
exports.DatetimeInput = DatetimeInput;
exports.FileInput = FileInput;
exports.ItemsInput = ItemsInput;
exports.MaskInput = MaskInput;
exports.MobileInput = MobileInput;
exports.NumberInput = NumberInput;
exports.OtpInput = OtpInput;
exports.PasswordInput = PasswordInput;
exports.SelectInput = SelectInput;
exports.TextInput = TextInput;
exports.TimeInput = TimeInput;
exports.ToggleInput = ToggleInput;
exports["default"] = FormBuilder;
