import { InputImplement } from '@/types';
import { DateValidationError, PickerChangeHandlerContext } from '@mui/x-date-pickers';
import { Dayjs } from 'dayjs';
import React, { Component } from "react";
import { DateInputProps, DateInputValueType } from './types';
interface IState {
    value: DateInputValueType;
    error: boolean;
}
export declare class DateInput extends Component<DateInputProps, IState> implements InputImplement<DateInputValueType> {
    state: IState;
    validationTimeout: NodeJS.Timeout | undefined;
    inputRef: HTMLInputElement | null | undefined;
    shouldComponentUpdate(nextProps: DateInputProps, nextState: IState): boolean;
    setValue(value: DateInputValueType): Promise<DateInputValueType>;
    getValue(): DateInputValueType;
    clear(): Promise<DateInputValueType>;
    validation(): boolean;
    onChange: (value: Dayjs | null, context: PickerChangeHandlerContext<DateValidationError>) => void;
    private onClick;
    click: () => void;
    focus: () => void;
    blur: () => void;
    render(): React.JSX.Element;
}
export {};
