import { DateTimeValidationError, PickerChangeHandlerContext } from '@mui/x-date-pickers';
import React, { Component } from "react";
import { InputImplement } from '@/types';
import { Dayjs } from 'dayjs';
import { DatetimeInputProps, DatetimeInputValueType } from './types';
interface IState {
    value: DatetimeInputValueType;
    error: boolean;
}
export declare class DatetimeInput extends Component<DatetimeInputProps, IState> implements InputImplement<DatetimeInputValueType> {
    state: IState;
    validationTimeout: NodeJS.Timeout | undefined;
    inputRef: HTMLInputElement | null | undefined;
    shouldComponentUpdate(nextProps: DatetimeInputProps, nextState: IState): boolean;
    setValue(value: DatetimeInputValueType): Promise<DatetimeInputValueType>;
    getValue(): DatetimeInputValueType;
    clear(): Promise<DatetimeInputValueType>;
    validation(): boolean;
    onChange: (value: Dayjs | null, context: PickerChangeHandlerContext<DateTimeValidationError>) => void;
    private onClick;
    click: () => void;
    focus: () => void;
    blur: () => void;
    render(): React.JSX.Element;
}
export {};
