import { InputImplement, OutputValues } from '@/types';
import React, { Component, RefObject } from "react";
import { FormBuilder } from "@/formBuilder";
import { GroupInputProps, GroupInputValueType } from './types';
interface IState {
    error: boolean;
    value: GroupInputValueType;
}
export declare class GroupInput extends Component<GroupInputProps, IState> implements InputImplement<GroupInputValueType> {
    state: IState;
    validationTimeout: NodeJS.Timeout | undefined;
    builderRef: RefObject<FormBuilder>;
    constructor(props: GroupInputProps);
    setValue(values: GroupInputValueType): Promise<GroupInputValueType>;
    getValue(validation?: boolean): GroupInputValueType;
    clear(): Promise<GroupInputValueType>;
    validation(): boolean;
    onChangeValue: (data: OutputValues) => void;
    click: () => void;
    focus: () => void;
    blur: () => void;
    render(): React.JSX.Element;
}
export {};
