import React, { Component } from "react";
import { InputImplement } from '@/types';
import { MaskInputProps, MaskInputValueType } from './types';
interface IState {
    value: MaskInputValueType;
    value_when_focus: MaskInputValueType;
    error: boolean;
}
export declare class MaskInput extends Component<MaskInputProps, IState> implements InputImplement<MaskInputValueType> {
    state: IState;
    validationTimeout: NodeJS.Timeout | undefined;
    inputRef: HTMLInputElement | undefined;
    shouldComponentUpdate(nextProps: MaskInputProps, nextState: IState): boolean;
    setValue(value: MaskInputValueType, withoutEffect?: boolean): Promise<MaskInputValueType>;
    getValue(): MaskInputValueType;
    clear(): Promise<MaskInputValueType>;
    validation(): boolean;
    onChange: (event: React.ChangeEvent<HTMLInputElement>) => void;
    private normalizeValue;
    private onClick;
    private onBlur;
    private onFocus;
    click: () => void;
    focus: () => void;
    blur: () => void;
    render(): React.JSX.Element;
}
export {};
