import { InputImplement } from '@/types';
import { PickerChangeHandlerContext, TimeValidationError } from '@mui/x-date-pickers';
import { Dayjs } from 'dayjs';
import React, { Component } from "react";
import { TimeInputProps, TimeInputValueType } from './types';
interface IState {
    value: TimeInputValueType;
    error: boolean;
}
export declare class TimeInput extends Component<TimeInputProps, IState> implements InputImplement<TimeInputValueType> {
    state: IState;
    validationTimeout: NodeJS.Timeout | undefined;
    shouldComponentUpdate(nextProps: TimeInputProps, nextState: IState): boolean;
    setValue(value: TimeInputValueType): Promise<TimeInputValueType>;
    getValue(): TimeInputValueType;
    clear(): Promise<TimeInputValueType>;
    validation(): boolean;
    onChange: (value: Dayjs | null, context: PickerChangeHandlerContext<TimeValidationError>) => void;
    private onClick;
    inputRef: HTMLInputElement | null | undefined;
    click: () => void;
    focus: () => void;
    blur: () => void;
    render(): React.JSX.Element;
}
export {};
