import React, { Component } from "react";
import { InputImplement } from '@/types';
import { ToggleInputProps, ToggleInputValueType } from './types';
interface IState {
    value: ToggleInputValueType;
    error: boolean;
}
export declare class ToggleInput extends Component<ToggleInputProps, IState> implements InputImplement<ToggleInputValueType> {
    state: IState;
    validationTimeout: NodeJS.Timeout | undefined;
    inputRef: HTMLInputElement | undefined;
    shouldComponentUpdate(nextProps: ToggleInputProps, nextState: IState): boolean;
    setValue(value: ToggleInputValueType): Promise<ToggleInputValueType>;
    getValue(): ToggleInputValueType;
    clear(): Promise<ToggleInputValueType>;
    validation(): boolean;
    onChange: (_: React.MouseEvent<HTMLElement>, value: ToggleInputValueType) => void;
    click: () => void;
    focus: () => void;
    blur: () => void;
    render(): React.JSX.Element;
}
export {};
